/***************************************************************************************************/
/* pp00animationtestbed.pov  - Copyright Chris Bartlett 2005                                       */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/

#version 3.5;
#ifndef(ppCamera)  #declare ppCamera="Front Left";  #end      // Required to prevent camera definitions in the include files being used.
#include "povperson.inc"
#include "arrays.inc"

#ifndef (ppAnimationName )      #declare ppAnimationName      = "ppwalking";  #end
#ifndef (ppAnimationPose)      #declare ppAnimationPose     = array[1] {1}; #end
#ifndef (ppAnimationThisPose)  #declare ppAnimationThisPose = 1;            #end
#ifndef (ppAnimationGhosts   )  #declare ppAnimationGhosts    = 0;            #end

#local ppI=0;
#while (ppI<dimension_size(ppAnimationPose,1))
  #if (ppAnimationPose[ppI]=1)
    #if (ppAnimationThisPose!=ppI)
      #if (ppAnimationGhosts!=0) 
        #declare ppSkinTexture = texture {pigment {color rgbt (<0.8,0.8,0.8>/abs(ppAnimationThisPose-ppI))+t*ppAnimationGhosts}};
      #else
        #declare ppSkinTexture = texture {pigment {color rgb 0.8/abs(ppAnimationThisPose-ppI)}};
      #end 
    #end
    #declare person = ppFigure("ppann.inc","ppstyle4.inc","pplookstraight.inc",concat(ppAnimationName,str(ppI,0,0),".inc"),"none")
    object {person rotate 180*y translate <-0.75,0, 0.25>}
    object {person rotate -90*y translate < 1   ,0,-0.25>}

    #debug concat ("Left Foot position:"    ,vstr(3,ppBodyPartListPosition   [ppLeftFootRef] ,",",3,3),"\n")
    #debug concat ("Left Foot orientation:" ,vstr(3,ppBodyPartListOrientation[ppLeftFootRef] ,",",3,3),"\n")
    #debug concat ("Right Foot position:"   ,vstr(3,ppBodyPartListPosition   [ppRightFootRef],",",3,3),"\n")
    #debug concat ("Right Foot orientation:",vstr(3,ppBodyPartListOrientation[ppRightFootRef],",",3,3),"\n")

    ppUndef(1,1,1,1,1)
  #end
  #local ppI = ppI + 1;  
#end

plane {y,0 pigment {color rgb 0.4*<1,1,0.5>}}

 
#if (strcmp(ppCamera,"Portrait")=0)
  light_source { < 2, 60  ,-30> color rgb<1, 1  , 1  >*0.6 }   
  light_source { < 0, 24  ,-26> color rgb<1, 1  , 1  >*1.2 }   
  light_source { <5,  6.5,-10> color rgb<1, 0.5, 0.5>}   
  camera {  
    location <0, 1.78,-0.9>
    look_at  <0.12, 1.76, 0>
    right x*0.8
    up y*0.8*3/4
  }
#end 

#if (strcmp(ppCamera,"Front")=0)
  light_source { < 2, 60  ,-30> color rgb<1, 1  , 1  >*0.6 }   
  light_source { < 0, 24  ,-26> color rgb<1, 1  , 1  >*1.2 }   
  light_source { <5,  6.5,-10> color rgb<1, 0.5, 0.5>}   
  camera {  
    location <-0.75, 1.5,-3>
    look_at  <-0.75, 1, 0>
  }
#end 

#if (strcmp(ppCamera,"Front Left")=0)
  light_source { < 2, 60  ,-30> color rgb<1, 1  , 1  >*0.6 }   
  light_source { < 0, 24  ,-26> color rgb<1, 1  , 1  >*1.2 }   
  light_source { <5,  6.5,-10> color rgb<1, 0.5, 0.5>}   
  camera {  
    location <0, 1.5,-3>
    look_at  <0, 1, 0>
  }
#end 
  
#if (strcmp(ppCamera,"Back Right")=0)
  light_source { < 2, 60  ,30> color rgb<1, 1  , 1  >*0.6 }   
  light_source { < 0, 24  ,26> color rgb<1, 1  , 1  >*1.2 }   
  light_source { <5,  6.5,10> color rgb<1, 0.5, 0.5>}   
  camera {  
    location <0, 1.5,3>
    look_at  <0, 1, 0>
  }
#end