/***************************************************************************************************/
/* eye.inc  - Copyright Chris Bartlett 7 May 2004                                                  */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/

#ifndef (ppCamera)        #declare ppCamera="Eyeball";      #end
#ifndef (ppEyeColour)     #declare ppEyeColour = 3;     #end                       
#ifndef (ppEyeBrightness) #declare ppEyeBrightness = 1; #end                       
#ifndef (ppEyePupil)      #declare ppEyePupil = 1;      #end                                                   

#declare ppEye1 = union {
  difference {   
    sphere {<0,0,0>,6.2
      texture {
        pigment { color rgb<1, 0.9020, 0.9020> }
        finish { ambient rgb<0.3000, 0.3000, 0.3000> diffuse 0.8000 phong 1 }
      }
    }     
    sphere {<0,0,0>,6.15
      texture {
        pigment { color rgb<1, 0, 0> }
      }
    }     
    cylinder {<0,0,-5.8>,<0,0,-6.5>,1.94
      texture {
        pigment { color rgb<1, 0, 0> }
      }
    }  
  }
  disc {
    <0, 0, 0>  // center position
    z,         // normal vector
    1.94,      // outer radius
    ppEyePupil   // iris radius    
    texture {   
      pigment { radial frequency 6        turbulence 0.25  
        #if (ppEyeColour=1)
          color_map {
            [0    color rgb <0.9,1,1>     * ppEyeBrightness]  
            [0.25 color rgb <0.4,0.7,0.7> * ppEyeBrightness]  
            [0.5  color rgb <0.7,1,1>     * ppEyeBrightness]  
            [0.75 color rgb <0.4,0.7,0.7> * ppEyeBrightness]  
            [1    color rgb <0.9,1,1>     * ppEyeBrightness]  
          }                        
        #end
        #if (ppEyeColour=2)
          color_map {
            [0    color rgb <0.5,0.25,0.25>    * ppEyeBrightness]  
            [0.25 color rgb <0.25,0.125,0.125> * ppEyeBrightness]  
            [0.5  color rgb <0.5,0.25,0.25>    * ppEyeBrightness]  
            [0.75 color rgb <0.25,0.125,0.125> * ppEyeBrightness]  
            [1    color rgb <0.5,0.25,0.25>    * ppEyeBrightness]  
          }                        
        #end
        #if (ppEyeColour=3)
          color_map {
            [0    color rgb <0.25,0.5,0.25>    * ppEyeBrightness]  
            [0.25 color rgb <0.125,0.25,0.125> * ppEyeBrightness]  
            [0.5  color rgb <0.25,0.5,0.25>    * ppEyeBrightness]  
            [0.75 color rgb <0.125,0.25,0.125> * ppEyeBrightness]  
            [1    color rgb <0.25,0.5,0.25>    * ppEyeBrightness]  
          }                        
        #end 
        }
      rotate x*90 scale <1,1,0.001>   
      }
    texture {
      pigment { spherical
        color_map {
          [0                 rgbt 0.2 ]  
          [0.2               rgbt <0.1,0.1,0.1,1> ]  
          [0.3               rgbt <1,1,1,1> ]
          [0.4               rgbt <1,1,1,0.9> ]
          [0.5               rgbt <1,1,1,1> ]
          [1-ppEyePupil/1.94   rgbt <1,1,1,0.6> ] 
        } 
      }
      scale 1.94
    } 
    translate <0, 0, -5.89>  
  }
  sphere { <0,0,-4>, 2.8
    texture {
      pigment {color rgbt <1,1,1,0.94>}
      finish {phong 1}
    }
  }
}


#if (strcmp(ppCamera,"Eyeball")=0)  
  camera {
    location <-10, 0, -20>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>}  
  object {ppEye1} 
#end                                                    
