/***************************************************************************************************/
/* ppf1bodyparts.inc  - Copyright Chris Bartlett 17 Nov 2004                                       */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/
#ifndef(ppCamera)  #declare ppCamera="ChestCamera"; #end  

#include "functions.inc"

//#declare ppBreastSize = 1;        // 0.9 - 1.2

#declare ppShoulder1 = blob {          // Left Shoulder
  threshold 0.2
  cylinder {< 0   ,-0.01,0.025><-0.09, 0   ,0.03 >,0.0165,0.9 scale <1,2,1.05>}    // Clevical
  cylinder {<-0.10, 0   ,0.03 ><-0.15,-0.01,0.03 >,0.0165,0.9 scale <1,2,1.05>}    // Clevical
  cylinder {<-0.16,-0.01,0.03 ><-0.30, 0   ,0.016>,0.0165,0.9 scale <1,2,1.05>}    // Clevical
  cylinder {<-0.3 , 0   ,0.016><-0.40, 0   ,0.002>,0.0165,0.9 scale <1,2,1.05>}    // Clevical

  sphere   {0,0.10, 1                   scale <1.5,1.2 ,1   > translate <-0.05, 0  ,-0.10>}    // Shoulder Blade 
  sphere   {0,0.17, 1                   scale <1.5,1.25,0.55> translate <-0.15,-0.1,-0.15>}    // Shoulder Blade 
  cylinder {0,<-0.1,0.02,0.05>,0.17,0.5 scale <1.5,1.25,0.55> translate <-0.15,-0.1,-0.15>}    // Shoulder Blade

  sphere   {0,0.35,0.3              scale <0.8,1,0.2>   rotate <-5,0,0> translate <-0.07,-0.14 ,0.035>}    // Front Inner Breast Plate 
  sphere   {0,0.35,0.3              scale <0.7,1.1,0.2> rotate <-5,-5,0> translate <-0.35 ,-0.15 ,0.032>}  // Front Outer Breast Plate 
  cylinder {<0,-0.06,-0.05>,<-0.38,-0.03,-0.04>,0.12,0.5 scale <1,1,0.9> rotate <-5,-4,0>}    // Core
  translate <-0.02,0.05,0.055>
//  rotate -z*10
  scale <0.4,0.7,0.5>  
} 

#ifndef(ppChestSize ) #declare ppChestSize  = 1;  #end      // 0.8 - 1.2
#ifndef(ppBreastSize) #declare ppBreastSize = 1;  #end      // 0.8 - 1.2  
#declare ppBreastTexture = texture {pigment {color rgb <1,1,1>}};

#declare ppChest1 = union {

  blob {
    threshold 0.7
    cylinder {<-0.08,0,0.08>,<-0.12,0.40, 0>,0.25,0.85}    // Main Core
    cylinder {< 0.08,0,0.08>,< 0.12,0.40, 0>,0.25,0.85}    // Main Core
    cylinder {<-0.14,0,0>,<-0.18,0.22, 0>,0.20,0.85}    // Left Padding
    cylinder {< 0.14,0,0>,< 0.18,0.22, 0>,0.20,0.85}    // Right Padding
    cylinder {<-0.20,0,0.03>,<-0.24,0.22, 0>,0.15,0.85}    // Left Side
    cylinder {< 0.20,0,0.03>,< 0.24,0.22, 0>,0.15,0.85}    // Right Side
    sphere {0,0.20, 1 translate < 0,0.25,0.05>}      // Core 
    sphere {0,0.25, 1 scale <1.1,1,0.8> translate <-0.18,0.18,0.1>}      // Core Left
    sphere {0,0.25, 1 scale <1.1,1,0.8> translate < 0.18,0.18,0.1>}      // Core Right
    sphere {0,0.125*ppChestSize, 2 scale <1.55,1.5,1> rotate <-15,0,-10> translate <-0.135,0.17,0.11>}      // Left Breast 
    sphere {0,0.125*ppChestSize, 2 scale <1.55,1.5,1> rotate <-15,0, 10> translate < 0.135,0.17,0.11>}      // Right Breast
  
  }
 
  blob { 
    threshold 0.7
    sphere {0,0.17*ppBreastSize,  2   scale <1.5,1.6,1> rotate <-15,0,-15> translate <-0.15,0.19,0.135>}      // Left Breast 
    sphere {0,0.14*ppBreastSize, -0.4 scale <2,2.1,0.8> rotate < 30,0,-15> translate <-0.14,0.19,0.125>}      // Left Breast 
    sphere {0,0.19*ppBreastSize,  0.4 scale <1,1,1>     translate <-0.14,0.125,0.175> texture {ppBreastTexture}}      // Left Breast 
  }
  blob { 
    threshold 0.7
    sphere {0,0.17*ppBreastSize,  2   scale <1.5,1.6,1> rotate <-15,0, 15> translate < 0.15,0.19,0.135>}      // Left Breast 
    sphere {0,0.14*ppBreastSize, -0.4 scale <2,2.1,0.8> rotate < 30,0, 15> translate < 0.14,0.19,0.125>}      // Left Breast 
    sphere {0,0.19*ppBreastSize,  0.4 scale <1,1,1>     translate < 0.145,0.125,0.175> texture {ppBreastTexture}}      // Left Breast 
  }

//  cylinder {< 0.37,0.42,0>,<-0.37,0.42,0>,0.005 pigment {color rgb <2,0,0>}}
//  sphere {0,0.065 translate < 0.37,0.42,0> pigment {color rgbt <2,1,1,0.9>}}      // Shoulder Joint 
//  sphere {0,0.065 translate <-0.37,0.42,0> pigment {color rgbt <2,1,1,0.9>}}      // Shoulder Joint 
  translate <0,-0.135,0>
  scale <0.53,0.62,0.65>  
}

#declare ppChest1_backup = blob {
  threshold 0.7
  cylinder {<-0.08,0,0.08>,<-0.12,0.40, 0>,0.25,0.85}    // Main Core
  cylinder {< 0.08,0,0.08>,< 0.12,0.40, 0>,0.25,0.85}    // Main Core
  cylinder {<-0.14,0,0>,<-0.18,0.22, 0>,0.20,0.85}    // Left Padding
  cylinder {< 0.14,0,0>,< 0.18,0.22, 0>,0.20,0.85}    // Right Padding
  cylinder {<-0.20,0,0.03>,<-0.24,0.22, 0>,0.15,0.85}    // Left Side
  cylinder {< 0.20,0,0.03>,< 0.24,0.22, 0>,0.15,0.85}    // Right Side
  sphere {0,0.20, 1 translate < 0,0.25,0.05>}      // Core 
  sphere {0,0.25, 1 scale <1.1,1,0.8> translate <-0.18,0.18,0.1>}      // Core Left
  sphere {0,0.25, 1 scale <1.1,1,0.8> translate < 0.18,0.18,0.1>}      // Core Right
  sphere {0,0.12*ppBreastSize, 3 scale <1.4,1.6,1> rotate -x*25 translate <-0.16,0.18+(1-ppBreastSize)/5,0.15>}      // Left Breast 
  sphere {0,0.12*ppBreastSize, 3 scale <1.4,1.6,1> rotate -x*25 translate < 0.16,0.18+(1-ppBreastSize)/5,0.15>}      // Right Breast

//  sphere {0,0.15, 1 translate < 0.37,0.42,0>}      // Shoulder Joint 
//  sphere {0,0.15, 1 translate <-0.37,0.42,0>}      // Shoulder Joint 
  translate <0,-0.135,0>
  scale <0.53,0.62,0.65>  
} 
#declare ppAbdomen1 = blob {
  threshold 0.7
  cylinder {<-0.15, 0.25,-0.04>,<-0.14,0.40,-0.06>,0.22,0.80}    // Main Core
  cylinder {< 0.15, 0.25,-0.04>,< 0.14,0.40,-0.06>,0.22,0.80}    // Main Core
  cylinder {<-0.09,-0.15,-0.01>,<-0.20,0.42,-0.05>,0.20,0.85}    // Left Padding
  cylinder {< 0.09,-0.15,-0.01>,< 0.20,0.42,-0.05>,0.20,0.85}    // Right Padding
  sphere {0,0.63, 1  scale <1.2,1.99,0.8> translate < 0,0.10,0.07>}      // Tummy 
  sphere {0,0.20,-0.05  scale <0.9,1.15,1.2> translate < 0,0.18,0.12>}      // Tummy Flattening
  sphere {0,0.20,-0.04  scale <0.5,1.8,2.4> translate < 0,0.12,0.12>}      // Tummy Flattening
  sphere {0,0.17,-0.05  scale <0.4,0.4,1.2> translate < 0,0.10,0.12>}      // Tummy Dimple 
  sphere {0,0.09 ,-0.06  scale <0.4,0.4,2.2> translate < 0,0.10,0.12>}      // Tummy Dimple 
  sphere {0,0.02,1  scale <0.45,1.2,1> rotate  z*40 translate < 0,0.10,0.23>}      // Tummy Button 
  sphere {0,0.02,1  scale <0.35,1  ,1> rotate -z*45 translate < 0,0.10,0.233>}      // Tummy Button 
  scale <0.46,0.48,0.48>  //scale <0.52,0.56,0.58>
  translate <0,-0.12,0>
} 

#declare ppAbdomen1_backup = blob {
  threshold 0.7
  cylinder {<-0.15, 0.25,-0.04>,<-0.14,0.40,-0.06>,0.22,0.80}    // Main Core
  cylinder {< 0.15, 0.25,-0.04>,< 0.14,0.40,-0.06>,0.22,0.80}    // Main Core
  cylinder {<-0.09,-0.15,-0.01>,<-0.20,0.42,-0.05>,0.20,0.85}    // Left Padding
  cylinder {< 0.09,-0.15,-0.01>,< 0.20,0.42,-0.05>,0.20,0.85}    // Right Padding
  sphere {0,0.63, 1  scale <1.2,1.8,0.8> translate < 0,0.16,0.07>}      // Core 
  sphere {0,0.17,-0.12  scale <0.7,1.25,1.2> translate < 0,0.18,0.18>}      // Tummy Dimple 
  sphere {0,0.02,1  scale <0.45,1.2,1> rotate  z*40 translate < 0,0.18,0.230>}      // Tummy Button 
  sphere {0,0.02,1  scale <0.35,1  ,1> rotate -z*45 translate < 0,0.18,0.233>}      // Tummy Button 
  scale <0.46,0.48,0.48>  //scale <0.52,0.56,0.58>
  translate <0,-0.12,0>
} 


#declare ppHips1 = blob {
  threshold 0.1
  sphere {0,0.2, 1 scale <0.8,1,1.4> translate <-0.1,-0.05,-0.06>}      // Left  Buttock 
  sphere {0,0.2, 1 scale <0.8,1,1.4> translate < 0.1,-0.05,-0.06>}      // Right Buttock 
  cylinder {<-0.1,-0.05,-0.1>,<-0.07,0.08,-0.06>,0.16,1 scale <1,1,1.2>}    // Left Back
  cylinder {< 0.1,-0.05,-0.1>,< 0.07,0.08,-0.06>,0.16,1 scale <1,1,1.2>}    // Right Back
  sphere {0,0.16, 1   scale <0.5,1,1>  translate < 0   ,-0.05,0.045>}      // Base 
  sphere {0,0.20, 0.7 scale <1.2,1,1> translate < 0   ,0,0.04>}      // Core 
  scale <0.84,0.77,0.55>
  translate <0,0,-0.04>
} 
 
#declare ppUpperArm1 = blob {
  threshold 0.7
  cylinder {0,z,1.5,0.7}
  sphere {0,1.5,0.07}

}

#declare ppForeArmTwist = 0;

#declare ppForeArm1 = blob {
  threshold 0.7
  cylinder {vrotate(<0    ,0   , 0.022>,ppForeArmTwist*y)  ,<0,0.36, 0.035>,0.050,0.85}     // Forward strut
  cylinder {vrotate(<0    ,0   ,-0.022>,ppForeArmTwist*y)  ,<0,0.36,-0.035>,0.049,0.85}     // Rear strut
  cylinder {vrotate(<0.005,0   , 0    >,ppForeArmTwist*y)  ,<-0.029,0.36,0>,0.046,0.85}     // Elbow Strut
  cylinder {vrotate(<-0.01,0.18,-0.01 >,ppForeArmTwist*y/2),<-0.005,0.36,0>,0.25,0.40}      // Padding
  cylinder {vrotate(<-0.01,0.31, 0    >,ppForeArmTwist*y/8),<0,0.36,0>,0.35,0.35}           // Padding
  cylinder {vrotate(<0    ,0   , 0.022>,ppForeArmTwist*y)  ,vrotate(<-0.018,0,-0.022>,ppForeArmTwist*y),0.03,0.4}     // Wrist
  sphere {0,0.19,0.08 scale <0.45,1.9,2> translate <-0.01,0.18,0.06> rotate ppForeArmTwist*y/4} // Main Muscle
  sphere {0,0.10,0.2                     translate <0,0.12,0>        rotate ppForeArmTwist*y/2} // Lower Muscle
  translate -y*0.36
  scale <0.72,0.72,0.6>*0.95
} 

#declare ppUpperArm1 = blob {
  threshold 0.7
  cylinder {0,<0,0.42, 0>,0.15,0.85}    // Main Core
  sphere {<0  ,0.42, 0>,0.1 ,0.8}       // Shoulder
  sphere {0,0.15, 0.6 scale <0.88,1.2 ,1.3> translate <0.1 ,0.44,0   >} // Shoulder Joint
  sphere {0,0.18, 0.7 scale <0.92,1.2 ,1>   translate <0   ,0.26,0.01>} // Upper Muscle
  sphere {0,0.10, 0.6 scale <1   ,1.35,1>   translate <0   ,0.09,0   >} // Lower Muscle
  sphere {0,0.10,-0.5 scale <1   ,1.20,1.2> translate <0.16,0.32,0   >} // Shoulder Joint
  translate -y*0.4
  scale <0.62,0.72,0.7>*1.05
} 


#declare ppFingerTip1 = blob {
  threshold 0.5
  sphere {<0,0,0>,0.39,1 scale <1,0.9,2>}
  sphere {<0,0.05,0.3>,0.28,1}
  sphere {<0,0.2,0.28>,0.2,-1 scale <1.2,1,1>}
  sphere {<0,0.2,0>,0.4,-0.1}
  sphere {<0,0.1,0.09>,0.1,1 scale <1.5,1,1>}
  sphere {<0,-0.01,-0.10>,0.4,0.1 scale <1,0.8,1>}
  sphere {<0,0,-0.35>,0.18,-0.5}
  translate <0,-0.06,0.24>
  scale <1,1,0.9>*0.05
}




#declare ppFingerMiddleSegment1 = blob {
  threshold 0.7
  cylinder {0,z,1.5,0.7}
  sphere {0,1.5,0.07}
  sphere {z,0.75,0.035}
  sphere {<0,0.4,0.50>,0.36,0.014}
  sphere {-z*1.5,1.5,-0.35}
  sphere {<0,-2.7,1.5>,3,-0.63}
  sphere {z*2.25,1.5,-0.56}
  sphere {<0,-2.7,-0.75>,3,-0.63}
  translate <0,-0.12,0.05>
  scale <1,1,0.9>*0.04
}

#declare ppFingerBaseOuterSegment1 = blob {
  threshold 0.7
  cylinder {0,1.7*z,1.6,0.8 scale <1.2,1,1>}
  cylinder {<0.2,-0.35,0.1>,<1,-0.4,0.1>,0.9,0.24 scale <1.2,0.8,0.9>}
  sphere {<0,-0.15,1>,0.74,0.048}
  sphere {<0,0.4,0>,0.3,0.02 scale <1,1,1.25>}
  sphere {<0,-0.3,3>,1.5,-0.56}
  sphere {<0,-0.1,-1>,1,-0.5}
  translate <0,-0.12,0.05> 
  scale 0.7*0.04
}


#declare ppFingerBaseInnerSegment1 = blob {
  threshold 0.7
  cylinder {0,1.7*z,1.6,0.8 scale <1.2,1,1>}
  cylinder {<-1,-0.4,0.1>,<1,-0.4,0.1>,0.9,0.24 scale <1.2,0.8,0.9>}
  sphere {<0,-0.15,1>,0.74,0.048}
  sphere {<0,0.4,0>,0.3,0.02 scale <1,1,1.25>}
  sphere {<0,-0.3,3>,1.5,-0.56}
  sphere {<0,-0.1,-1>,1,-0.5}
  translate <0,-0.12,0.05>  
  scale 0.7*0.04
}

#declare ppFingerJointPos = array[3];
#declare ppFingerJointPos[0] = < 0    , 0    ,0.05  >; // Base   -> Middle
#declare ppFingerJointPos[1] = < 0    , 0    ,0.033 >; // Middle -> Tip     
#declare ppFingerJointPos[2] = 0.05*<0,0.157,0.25>; // Tip    -> Nail


#declare ppThumbBase1 = blob {
  threshold 0.7
  cylinder {0,2*z,1.6,0.75 scale <1.2,1,1>}
  sphere {<0,0,1.5>,1,0.05}
  sphere {<0,-0.4,0.2>,1.2,0.3 scale <1,1,1.2>}
  sphere {<0,-0.8,0.2>,1.2,0.3 scale <1,0.5,1.2> rotate <-30,0,120> translate <-0.6,-0.6,0.3>}
  sphere {<0,-0.3,3>,1.5,-0.56}
  translate <0,-0.12,0.05> 
  scale 0.7
  scale 0.04 
}

#declare ppThumbJointPos = array[3];
#declare ppThumbJointPos[0] = <0,0,0.045 >; // Base   -> Middle
#declare ppThumbJointPos[1] = <0,0,0.034 >; // Middle -> Tip     
#declare ppThumbJointPos[2] = 0.05*<0, 0.157,0.25>; // Tip    -> Nail

#declare ppPalm1 = blob {
  threshold 0.7
  cylinder {<-1.00,-0.9,-0.4>,<-1.10,-0.7,3.2>,0.85,1 scale <1,1.4,1>}
  cylinder {<-0.35,-0.5,-1.6>,<-0.45,-0.5,3.4>,0.9 ,1 scale <1,1.4,1>}
  cylinder {< 0.35,-0.5,-1.6>,< 0.45,-0.5,3.4>,0.9 ,1 scale <1,1.4,1>}
  cylinder {< 0.9 ,-0.8,-0.8>,< 1.20,-0.9,3.2>,0.9 ,1 scale <1,1.4,1>}
//  cylinder {<-1.00,-0.5 ,3.2>< 1.15,-0.6 ,3.2>,2 ,0.4}      // Knuckles
  sphere {0,2.5,0.8  scale <0.8,0.7,1.4> translate <-0.7 ,-0.6,0.4>}
  sphere {0,2.5,1    scale <1.0,0.9,1.6> translate < 0.7,-0.9,-0.4>}
//  sphere {0,1.4,0.8 translate <1,-0.7,-0.5>}
//  cylinder {<-0.5, -0.2,-1><0.5,-0.2,-1>,2 ,0.7 scale <1,1,1>}
  cylinder {<-0.6,-0.5,-1.7><0.6,-0.5,-1.7>,0.9 ,0.7 } // pigment {rgb <1,0,0>}
  translate <0,0.25,1.85> 
  scale <0.68,0.7,0.5>
  scale 0.037
} 

#declare ppPalm1WristPos   = < 0    , 0    ,0    >;
#declare ppPalm1ThumbPos   = < 0.042,-0.020,0.020>;
#declare ppPalm1Finger1Pos = < 0.032,-0.025,0.09 >;
#declare ppPalm1Finger2Pos = < 0.014,-0.009,0.094>;
#declare ppPalm1Finger3Pos = <-0.011,-0.007,0.093>;
#declare ppPalm1Finger4Pos = <-0.030,-0.018,0.09 >;      

#ifndef (ppFingerNailTexture) #declare ppFingerNailTexture = texture {pigment {rgb <1,0,0>}} #end

#declare ppFingerNail1 = intersection {
  isosurface {
    function { abs(- f_superellipsoid(x*0.8,y,z*0.3,0.7,0.7)) -0.002}
    max_gradient 1
    accuracy 0.00005
    contained_by{sphere{<0,1,0>,0.9}}
    scale <0.8,1,2>
  }
  box {<-1,0.9,-2><1,1.1,2>}
  rotate -x*2.2 
  translate -y
  scale <0.26,0.5,0.15>
  translate <0,-0.06,0.24>
  translate <0,0.157,0.25>
  scale 0.05
}


#declare ppFoot1 = blob {
  threshold 0.7
  sphere {0,2.5,1.1 translate <0,0.25,0>} //-0.25>}                                                            // Heel
  cylinder {<0,0.6,0>,<0,2.1,0>,1.55,0.7 scale <0.5,1,1> translate <0,0,0.24>}                                 // Tendon
  cylinder {<0,0.6,0>,<0,1.4,0>,1,1 translate z*0.5}                                                           //
  sphere {0,1.4,1   scale <1.2,1,2.2> rotate x*30 translate <-0.21,0.40,2>   }  // pigment {color rgb <1,0,0>} // Core
  sphere {0,1.2,0.5 scale <1.2,1,1.5> rotate x*30 translate <-0.6 ,0.25,2.2> }  // pigment {color rgb <0,0,1>} // 

  cylinder {<-0.70,0.35,0>,<-1.0 ,-0.32,3.7 >,0.45,1 scale <1,1.1,1>  translate <0,0,0>}  // Little Toe Radial
  cylinder {<-0.45,1.08,0>,<-0.7 ,-0.30,4.0 >,0.50,1 scale <1,1.2,1>  translate <0,0,0>}
  cylinder {<-0.15,1.34,0>,<-0.1 ,-0.28,4.3 >,0.55,1 scale <1,1.3,1>  translate <0,0,0>}
  cylinder {< 0.15,1.34,0>,< 0.5 ,-0.25,4.4 >,0.58,1 scale <1,1.3,1>  translate <0,0,0>}
  cylinder {< 0.3 ,0.50,0>,< 1.0 ,-0.15,3.6 >,0.68,1 scale <1,1.5,1>  translate <0,0,0>}  // Big Toe Radial

  sphere {0,1.1,1    scale <0.9,0.7,1.1> translate < 1.00,-0.25,3.8 >}                    // Ball at root of Big Toe
  sphere {0,2.4,0.80 scale <1,0.4,0.9>   translate < -0.8,-0.5 ,3.6 >}                    // Pad at front of foot
  sphere {0,2.2,0.4  scale <1,0.35,1>    translate <  0.5,-0.6 ,4 >}                      // Pad at front centre

  cylinder {<-0.8,-0.30,2.9>,< 0.60,-0.35,3.2 >,1.0,0.6}                                  // Arch of the foot
  cylinder {<-0.8,-0.30,2.5>,< 0.60,-0.30,2.5 >,0.7,0.8}                                  // 
  cylinder {<-0.7,-0.20,1.9>,< 0.50,-0.25,2.0 >,0.7,0.8}                                  // 
  cylinder {<-0.6,-0.10,1.3>,< 0.50,-0.15,1.5 >,0.7,0.8}                                  // 
  cylinder {<-0.5,-0.05,0.8>,< 0.50,-0.10,1.0 >,0.7,0.8}                                  // 

  translate <0,0.6,-0.2> 
//  scale <0.94,0.94,0.94>
  scale 0.042
} 

#declare ppFoot1AnklePos  = <0,0.1,0>;
#declare ppFoot1BigToePos = < 0.044,0.020,0.145>;
#declare ppFoot1Toe1Pos   = < 0.018,0.015,0.165>;
#declare ppFoot1Toe2Pos   = <-0.000,0.015,0.165>;
#declare ppFoot1Toe3Pos   = <-0.024,0.015,0.16 >;
#declare ppFoot1Toe4Pos   = <-0.045,0.014,0.145>;      


#declare ppToeTip1       = object {ppFingerTip1               scale <1.1 ,1.1 ,0.75>}
#declare ppToeNail1      = object {ppFingerNail1              scale <1.1 ,1.1 ,0.75>}
#declare ppToeMiddle1    = object {ppFingerMiddleSegment1     scale <1.05,1.05,0.53>}                                                 
#declare ppToeBaseInner1 = object {ppFingerBaseInnerSegment1  scale <0.9 ,0.9 ,0.60>}
#declare ppToeBaseOuter1 = object {ppFingerBaseOuterSegment1  scale <0.9 ,0.9 ,0.60>} 

#declare ppToeJointPos = array[3];
#declare ppToeJointPos[0] = ppFingerJointPos[0]*<0.9 ,0.9 ,0.60>; // Base   -> Middle
#declare ppToeJointPos[1] = ppFingerJointPos[1]*<1.05,1.05,0.53>; // Middle -> Tip     
#declare ppToeJointPos[2] = ppFingerJointPos[2]*<1.1 ,1.1 ,0.6 >; // Tip    -> Nail



#declare ppCalf1 = blob {
  threshold 0.7
  cylinder {<0,0,0><0,0.40,0>,0.10,0.9 rotate -x*5}                     // Main Limb
  cylinder {<0,0,-0.01><0,0.40,0>,0.03,0.8 scale <1,1,1.35>}            // Heel
  sphere {0,0.12,0.7 scale <1,2,0.8> translate <0,0.30,-0.045>}         // Main Muscle
  sphere {0,0.07,0.8 scale <1,1.2,1>translate <0,0.40,0.010>}           // Knee Cap
  sphere {0,0.07,0.8 scale <1.2,1.6,0.9>translate <0,0.30,-0.040>}      // Muscle Emphasis
  scale 1.0
}

#declare ppThigh1 = blob {
  threshold 0.7
  cylinder {<0,0,0><0,0.45,0>,0.18,0.9 rotate -x*3}                     // Main Limb
  cylinder {< 0.02,0,-0.044>< 0.02,0.28,-0.11 >,0.015,0.8}              // Back Ligaments
  cylinder {<-0.02,0,-0.044><-0.02,0.28,-0.115>,0.015,0.8}              //
  sphere {0,0.2,0.85  scale <1,1.65,1.35> translate <-0.045,0.45,-0.02>}// Main Muscle
  sphere {0,0.04,1    scale <1,1.2,1> translate <0,0,0.030>}            // Knee Cap
  sphere {0,0.18,0.75 scale <1.2,1.6,1> translate <-0.01,0.29,0.00>}    // Muscle Emphasis
  sphere {0,0.2,1 translate <0.04,0.52,-0.1> } // pigment {color rgb <1,0,0>}     // Hip
  scale 0.85
}

#declare ppTrainer1 = blob {               // Not ready
  threshold 0.7
  sphere {0,2.5,1.1 translate <0,0.25,-0.25>}                                                                // Heel
  cylinder {<0,0.6,0>,<0,1,0>,1.55,0.7 scale <0.5,1,1> translate <0,0,0.24>}                                 // Tendon
  cylinder {<0,0.6,0>,<0,1,0>,1,1 translate z*0.5}                                                           //
  sphere {0,1.4,1   scale <1.2,1,2.2> rotate x*30 translate <-0.21,0.23,2>}   //pigment {color rgb <1,0,0>}  // Core
  sphere {0,1.2,0.5 scale <1.2,1,1.5> rotate x*30 translate <-0.6,0.14,2.2>}  //pigment {color rgb <0,0,1>}  // 

  cylinder {<-0.75,0.3 ,0>,<-1.2 ,-0.32,3.7 >,0.45,1 scale <1,1.1,1>  translate <0,0,0>}  // Little Toe Radial
  cylinder {<-0.45,1   ,0>,<-0.7 ,-0.30,4.0 >,0.50,1 scale <1,1.2,1>  translate <0,0,0>}
  cylinder {<-0.15,1.2 ,0>,<-0.1 ,-0.28,4.3 >,0.55,1 scale <1,1.3,1>  translate <0,0,0>}
  cylinder {< 0.15,1.23,0>,< 0.6 ,-0.25,4.4 >,0.58,1 scale <1,1.3,1>  translate <0,0,0>}
  cylinder {< 0.50,0.45,0>,< 1.25,-0.20,4.2 >,0.68,1 scale <1,1.5,1>  translate <0,0,0>}  // Big Toe Radial

  sphere {0,1.0,0.95 scale <1,0.9 ,1.0> translate < 1.20,-0.48,3.7 >}                     // Ball at root of Big Toe
  sphere {0,2.4,0.85 scale <1,0.35,1>   translate < -0.8,-0.5 ,3.5 >}                     // Pad at front of foot
  sphere {0,2.2,0.4  scale <1,0.35,1>   translate <  0.5,-0.6 ,3.9 >}                     // Pad at front centre

  cylinder {<-0.8,-0.30,2.9>,< 0.65,-0.35,3.2 >,1.0,0.6}                                  // Arch of the foot
  cylinder {<-0.8,-0.30,2.5>,< 0.65,-0.30,2.5 >,0.7,0.8}                                  // 
  cylinder {<-0.7,-0.20,1.9>,< 0.60,-0.25,2.0 >,0.7,0.8}                                  // 
  cylinder {<-0.6,-0.10,1.3>,< 0.60,-0.15,1.5 >,0.7,0.8}                                  // 
  cylinder {<-0.6,-0.05,0.8>,< 0.60,-0.10,1.0 >,0.7,0.8}                                  // 

  translate <0,0.6,-0.2> 
  scale <0.94,0.94,0.94>
}




#if (strcmp(ppCamera,"HandCamera")=0)
  camera {
    location <0, 0, -0.6>
    look_at <0, 0.016, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  #local ppxAxis = cylinder {<-0.05,0,0><0.05,0,0> 0.001 pigment {rgb <3,0,0>}}
  #local ppyAxis = cylinder {<0,-0.05,0><0,0.05,0> 0.001 pigment {rgb <3,3,0>}}
  #local ppzAxis = cylinder {<0,0,-0.05><0,0,0.05> 0.001 pigment {rgb <0,3,0>}}
  
  
  #declare ppPalm1 = union {
    object {ppPalm1}
    object {ppxAxis scale 0.7 translate ppPalm1WristPos}
    object {ppyAxis scale 0.7 translate ppPalm1WristPos}
    object {ppzAxis scale 0.7 translate ppPalm1WristPos}
    object {ppxAxis scale 0.5 translate ppPalm1ThumbPos}
    object {ppyAxis scale 0.5 translate ppPalm1ThumbPos}
    object {ppzAxis scale 0.5 translate ppPalm1ThumbPos}
    object {ppxAxis scale 0.5 translate ppPalm1Finger1Pos}
    object {ppyAxis scale 0.5 translate ppPalm1Finger1Pos}
    object {ppzAxis scale 0.5 translate ppPalm1Finger1Pos}
    object {ppxAxis scale 0.5 translate ppPalm1Finger2Pos}
    object {ppyAxis scale 0.5 translate ppPalm1Finger2Pos}
    object {ppzAxis scale 0.5 translate ppPalm1Finger2Pos}
    object {ppxAxis scale 0.5 translate ppPalm1Finger3Pos}
    object {ppyAxis scale 0.5 translate ppPalm1Finger3Pos}
    object {ppzAxis scale 0.5 translate ppPalm1Finger3Pos}
    object {ppxAxis scale 0.5 translate ppPalm1Finger4Pos}
    object {ppyAxis scale 0.5 translate ppPalm1Finger4Pos}
    object {ppzAxis scale 0.5 translate ppPalm1Finger4Pos}
  }

//  object {ppFingerTip1 pigment {color rgb <1,0.8,0.8>} translate x}
//  object {ppFingerMiddleSegment1 pigment {color rgb <1,0.8,0.8>}}
  object {ppPalm1 rotate <-90,0,0> pigment {color rgb <1,0.8,0.8>} translate -x*0.05}
  object {ppPalm1 rotate <-90,90,0> pigment {color rgb <1,0.8,0.8>} translate -x*0.145}
  object {ppPalm1 rotate <-90,270,0> pigment {color rgb <1,0.8,0.8>} translate x*0.05}
  object {ppPalm1 rotate <-90,180,0> pigment {color rgb <1,0.8,0.8>} translate x*0.125}
  
#end 

#if (strcmp(ppCamera,"FingerCamera")=0)
  camera {
    location <0, 0, -0.65>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  #local ppxAxis = cylinder {<-0.05,0,0><0.05,0,0> 0.001 pigment {rgb <3,0,0>}}
  #local ppyAxis = cylinder {<0,-0.05,0><0,0.05,0> 0.001 pigment {rgb <3,3,0>}}
  #local ppzAxis = cylinder {<0,0,-0.05><0,0,0.05> 0.001 pigment {rgb <0,3,0>}}
  
  
  #declare  ppFingerBaseInnerSegment1 = union {
    object {ppFingerBaseInnerSegment1}
    object {ppxAxis scale 0.7}
    object {ppyAxis scale 0.7}
    object {ppzAxis scale 0.7}
    object {ppxAxis scale 0.5 translate ppFingerJointPos[0]}
    object {ppyAxis scale 0.5 translate ppFingerJointPos[0]}
    object {ppzAxis scale 0.5 translate ppFingerJointPos[0]}
  } 

  #declare  ppFingerBaseOuterSegment1 = union {
    object {ppFingerBaseOuterSegment1}
    object {ppxAxis scale 0.7}
    object {ppyAxis scale 0.7}
    object {ppzAxis scale 0.7}
    object {ppxAxis scale 0.5 translate ppFingerJointPos[0]}
    object {ppyAxis scale 0.5 translate ppFingerJointPos[0]}
    object {ppzAxis scale 0.5 translate ppFingerJointPos[0]}
  } 

  #declare  ppFingerMiddleSegment1 = union {
    object {ppFingerMiddleSegment1}
    object {ppxAxis scale 0.7}
    object {ppyAxis scale 0.7}
    object {ppzAxis scale 0.7}
    object {ppxAxis scale 0.5 translate ppFingerJointPos[1]}
    object {ppyAxis scale 0.5 translate ppFingerJointPos[1]}
    object {ppzAxis scale 0.5 translate ppFingerJointPos[1]}
  } 

  #declare  ppFingerTip1 = union {
    object {ppFingerTip1}
    object {ppxAxis scale 0.7}
    object {ppyAxis scale 0.7}
    object {ppzAxis scale 0.7}
//    object {xAxis scale 0.5 translate ppFingerJointPos[2]}
//    object {yAxis scale 0.5 translate ppFingerJointPos[2]}
//    object {zAxis scale 0.5 translate ppFingerJointPos[2]}
  } 

  #declare  ppFingerNail1 = union {
    object {ppFingerNail1}
    object {ppxAxis scale 0.7}
    object {ppyAxis scale 0.7}
    object {ppzAxis scale 0.7}
  }

//  object {ppFingerTip1 pigment {color rgb <1,0.8,0.8>} translate x}
//  object {ppFingerMiddleSegment1 pigment {color rgb <1,0.8,0.8>}}
  object {ppFingerNail1             rotate <-90,0,0>   pigment {color rgb <1,0,0>}     translate <-0.075, 0.02,0>+vrotate(ppFingerJointPos[0],<-90,0,0>  )+vrotate(ppFingerJointPos[1],<-90,0,0>  )}
  object {ppFingerNail1             rotate <-90,90,0>  pigment {color rgb <1,0,0>}     translate <-0.175, 0.02,0>+vrotate(ppFingerJointPos[0],<-90,90,0> )+vrotate(ppFingerJointPos[1],<-90,90,0> )}
  object {ppFingerNail1             rotate <-90,270,0> pigment {color rgb <1,0,0>}     translate < 0.04 , 0.02,0>+vrotate(ppFingerJointPos[0],<-90,270,0>)+vrotate(ppFingerJointPos[1],<-90,270,0>)}
  object {ppFingerNail1             rotate <-90,180,0> pigment {color rgb <1,0,0>}     translate < 0.12 , 0.02,0>+vrotate(ppFingerJointPos[0],<-90,180,0>)+vrotate(ppFingerJointPos[1],<-90,180,0>)}
                                   
  object {ppFingerTip1              rotate <-90,0,0>   pigment {color rgb <1,0.8,0.8>} translate <-0.075,-0.02,0>+vrotate(ppFingerJointPos[0],<-90,0,0>  )+vrotate(ppFingerJointPos[1],<-90,0,0>  )}
  object {ppFingerTip1              rotate <-90,90,0>  pigment {color rgb <1,0.8,0.8>} translate <-0.175,-0.02,0>+vrotate(ppFingerJointPos[0],<-90,90,0> )+vrotate(ppFingerJointPos[1],<-90,90,0> )}
  object {ppFingerTip1              rotate <-90,270,0> pigment {color rgb <1,0.8,0.8>} translate < 0.04 ,-0.02,0>+vrotate(ppFingerJointPos[0],<-90,270,0>)+vrotate(ppFingerJointPos[1],<-90,270,0>)}
  object {ppFingerTip1              rotate <-90,180,0> pigment {color rgb <1,0.8,0.8>} translate < 0.12 ,-0.02,0>+vrotate(ppFingerJointPos[0],<-90,180,0>)+vrotate(ppFingerJointPos[1],<-90,180,0>)}
                                   
  object {ppFingerMiddleSegment1    rotate <-90,0,0>   pigment {color rgb <1,0.8,0.8>} translate <-0.075,-0.04,0>+vrotate(ppFingerJointPos[0],<-90,0,0>  )}
  object {ppFingerMiddleSegment1    rotate <-90,90,0>  pigment {color rgb <1,0.8,0.8>} translate <-0.175,-0.04,0>+vrotate(ppFingerJointPos[0],<-90,90,0> )}
  object {ppFingerMiddleSegment1    rotate <-90,270,0> pigment {color rgb <1,0.8,0.8>} translate < 0.04 ,-0.04,0>+vrotate(ppFingerJointPos[0],<-90,270,0>)}
  object {ppFingerMiddleSegment1    rotate <-90,180,0> pigment {color rgb <1,0.8,0.8>} translate < 0.12 ,-0.04,0>+vrotate(ppFingerJointPos[0],<-90,180,0>)}

  object {ppFingerBaseInnerSegment1 rotate <-90,0,0>   pigment {color rgb <1,0.8,0.8>} translate <-0.075,-0.06,0>}
  object {ppFingerBaseInnerSegment1 rotate <-90,90,0>  pigment {color rgb <1,0.8,0.8>} translate <-0.175,-0.06,0>}
  object {ppFingerBaseInnerSegment1 rotate <-90,270,0> pigment {color rgb <1,0.8,0.8>} translate < 0.04 ,-0.06,0>}
  object {ppFingerBaseInnerSegment1 rotate <-90,180,0> pigment {color rgb <1,0.8,0.8>} translate < 0.12 ,-0.06,0>}
                                                                                                              
  object {ppFingerBaseOuterSegment1 rotate <-90,0,0>   pigment {color rgb <1,1,1>}     translate <-0.03 ,-0.06,0>}
  object {ppFingerBaseOuterSegment1 rotate <-90,90,0>  pigment {color rgb <1,1,1>}     translate <-0.130,-0.06,0>}
  object {ppFingerBaseOuterSegment1 rotate <-90,270,0> pigment {color rgb <1,1,1>}     translate < 0.085,-0.06,0>}
  object {ppFingerBaseOuterSegment1 rotate <-90,180,0> pigment {color rgb <1,1,1>}     translate < 0.175,-0.06,0>}
  
#end  


                                                   

#if (strcmp(ppCamera,"UpperArmCamera")=0)
  camera {
    location <0, 0, -30>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  object {ppUpperArm1 rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 10 translate <-6,0,0>}
  object {ppUpperArm1 rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 10 translate <-2,0,0>}
  object {ppUpperArm1 rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 10 translate < 2,0,0>}
  object {ppUpperArm1 rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 10 translate < 6,0,0>}
  
  #declare ppxaxis = cylinder {<-5,0,0><5,0,0>0.01 pigment {rgb <1,1,0>}}
    
   
#end                                                    
 
#if (strcmp(ppCamera,"ForeArmCamera")=0)
  camera {
    location <0, 0, -30>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  object {ppForeArm1 rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 10 translate <-6,0,0>}
  object {ppForeArm1 rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 10 translate <-2,0,0>}
  object {ppForeArm1 rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 10 translate < 2,0,0>}
  object {ppForeArm1 rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 10 translate < 6,0,0>}
  
  cylinder {<-5,0,0><5,0,0>0.01 pigment {rgb <1,1,0>}}
   
#end                                                    


#if (strcmp(ppCamera,"FootCamera")=0)
  camera {
    location <0, 0, -30>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
//  object {ppFoot1 pigment {color rgb <1,0.8,0.8>}}
  object {ppFoot1 rotate <-90,0,-90> rotate x*00   pigment {color rgb <1,0.8,0.8>} translate < 2,2,0>}
  object {ppFoot1 rotate <-90,0,-90> rotate x*90   pigment {color rgb <1,0.8,0.8>} translate < 2,-4,0>}
  object {ppFoot1 rotate <-90,0,90>  rotate x*90   pigment {color rgb <1,0.8,0.8>} translate <-1,-4,0>}
  object {ppFoot1 rotate <-90,0,90>  rotate x*180  pigment {color rgb <1,0.8,0.8>} translate <-1,2,0>}
  object {ppFoot1 rotate <-90,0,210> rotate x*70   pigment {color rgb <1,0.8,0.8>} translate <-8,0,0>}
  
  cylinder {<-25,0,0><25,0,0>0.05 pigment {rgb <1,1,0>}}
//  cylinder {<-1.1,0.6,-5><-1.1,0.6,5>, 0.01 pigment {rgb <0,1,0>} translate -x*1.5}
   
#end                                                    

#if (strcmp(ppCamera,"CalfCamera")=0)
  camera {
    location <0, 0, -30>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  object {ppCalf1 rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 10 translate <-6,0,0>}
  object {ppCalf1 rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 10 translate <-2,0,0>}
  object {ppCalf1 rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 10 translate < 2,0,0>}
  object {ppCalf1 rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 10 translate < 6,0,0>}
  
  cylinder {<-5,0,0><5,0,0>0.01 pigment {rgb <1,1,0>}}
   
#end                                                    
 
#if (strcmp(ppCamera,"ThighCamera")=0)
  camera {
    location <0, 0, -30>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  object {ppThigh1 rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 10 translate <-6,0,0>}
  object {ppThigh1 rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 10 translate <-2,0,0>}
  object {ppThigh1 rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 10 translate < 2,0,0>}
  object {ppThigh1 rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 10 translate < 6,0,0>}
  
  cylinder {<-5,0,0><5,0,0>0.01 pigment {rgb <1,1,0>}}
   
#end    
 
 

#if (strcmp(ppCamera,"ChestCamera")=0)
  camera {
    location <0, 0, -17>
    look_at <0, -2, 0>
    angle 34.3775
  }
  
//  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  object {ppChest1 rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 6 translate <-3,0,0>}
  object {ppChest1 rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 6 translate <-1.2,0,0>}
  object {ppChest1 rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 6 translate < 1.2,0,0>}
  object {ppChest1 rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 6 translate < 3,0,0>}

  object {ppChest1 rotate  y*00   rotate -x*90 pigment {color rgb <1,0.8,0.8>} scale 6 translate <-3,-3,0>}
  
  cylinder {<-5,0,0><5,0,0>0.01 pigment {rgb <1,1,0>}}
   
#end                                                    
 
#if (strcmp(ppCamera,"ShoulderCamera")=0)
  camera {
    location <0, 0, -20>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
//  object {ppHips1 rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 9 translate <-6,0,0>}
//  object {ppHips1 rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 9 translate <-2,0,0>}
//  object {ppHips1 rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 9 translate < 2,0,0>}
//  object {ppHips1 rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 9 translate < 6,0,0>}

  object {ppShoulder1 rotate  y*00      pigment {color rgb <1,0.8,0.8>} scale 12 translate <-3,0,0>}
  object {ppShoulder1 rotate  y*90      pigment {color rgb <1,0.8,0.8>} scale 12 translate <-1,0,0>}
  object {ppShoulder1 rotate -y*90      pigment {color rgb <1,0.8,0.8>} scale 12 translate < 1,0,0>}
  object {ppShoulder1 rotate  y*180     pigment {color rgb <1,0.8,0.8>} scale 12 translate < 3,0,0>}
  object {ppShoulder1 rotate -x*90      pigment {color rgb <1,0.8,0.8>} scale 12 translate <-3,3,0>}
  object {ppShoulder1 rotate <90,180,0> pigment {color rgb <1,0.8,0.8>} scale 12 translate < 3,3,0>}
  
  cylinder {<-5,0,0><5,0,0>0.01 pigment {rgb <1,1,0>}}
   
#end                                                    

#if (strcmp(ppCamera,"HipCamera")=0)
  camera {
    location <0, 0, -20>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  object {ppHips1 rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 9 translate <-6,0,0>}
  object {ppHips1 rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 9 translate <-2,0,0>}
  object {ppHips1 rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 9 translate < 2,0,0>}
  object {ppHips1 rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 9 translate < 6,0,0>}

  
  cylinder {<-5,0,0><5,0,0>0.01 pigment {rgb <1,1,0>}}
   
#end                                                    

#if (strcmp(ppCamera,"AbdomenCamera")=0)
  camera {
    location <0, 0, -25>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
//  object {ppAbdomen1 rotate  y*00      pigment {color rgb <1,0.8,0.8>} scale 12 translate <-5  ,2.0,0>}
//  object {ppAbdomen1 rotate  y*90      pigment {color rgb <1,0.8,0.8>} scale 12 translate <-1.6,2.0,0>}
  object {ppAbdomen1 rotate -y*90      pigment {color rgb <1,0.8,0.8>} scale 12 translate < 1.6,2.0,0>}
  object {ppAbdomen1 rotate  y*180     pigment {color rgb <1,0.8,0.8>} scale 12 translate < 5  ,2.0,0>}
  
  cylinder {<-5,0,0><5,0,0>0.01 pigment {rgb <1,1,0>}}
   
#end                                                    
