/***************************************************************************************************/
/* ppf2eyelash.inc  - Copyright Chris Bartlett 3 Mar 2005                                          */
/* This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike License.  */
/* To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/1.0/ or      */
/* send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.      */
/***************************************************************************************************/ 

#ifndef (ppLashLength)     #declare ppLashLength    = 15;      #end
#ifndef (ppLashDensity)    #declare ppLashDensity   = 0.6;     #end
#ifndef (ppLashThickness)  #declare ppLashThickness = 0.026;   #end
#ifndef (ppLashColour)     #declare ppLashColour    = <0,0,0>; #end
#ifndef (ppEyeLashTexture) #declare ppEyeLashTexture = texture {pigment {color rgb ppLashColour}} #end 
#ifndef(POVPerson) #include "povperson.inc" #end

#declare ppUpperEyeLash = intersection {
  torus {4,0.1}
  torus {4,0.1 translate -z*0.22}
  box {<0,-0.1,-4.1><4.1,0.1,0>}
  texture {ppEyeLashTexture}
  translate -x*4 
  rotate -z*90 scale <70*ppLashThickness,54*ppLashThickness,0.14*ppLashLength> rotate -x*40
} 
#declare ppLowerEyeLash = intersection {
  torus {4,0.1}
  torus {4,0.1 translate -z*0.22}
  box {<0,-0.1,-4.1><4.1,0.1,0>}
  texture {ppEyeLashTexture}
  translate -x*4 
  rotate z*90 scale <25*ppLashThickness,25*ppLashThickness,0.08*ppLashLength>
} 

#declare ppUpperEyeLashSpacing = 0.67*ppLashDensity;
#declare ppLowerEyeLashSpacing = 0.83*ppLashDensity;

#declare ppLeftUpperLash1  = union {ppLineOfEyeLashes(object {ppUpperEyeLash}, ppLeftUpperLidArray , ppLeftUpperLidNormal , ppUpperLidLashLine, ppUpperLidSegments, ppUpperEyeLashSpacing, 1)}
#declare ppRightUpperLash1 = union {ppLineOfEyeLashes(object {ppUpperEyeLash}, ppRightUpperLidArray, ppRightUpperLidNormal, ppUpperLidLashLine, ppUpperLidSegments, ppUpperEyeLashSpacing,-1)}
#declare ppLeftLowerLash1  = union {ppLineOfEyeLashes(object {ppLowerEyeLash}, ppLeftLowerLidArray , ppLeftLowerLidNormal , ppLowerLidLashLine, ppLowerLidSegments, ppLowerEyeLashSpacing, 1)}
#declare ppRightLowerLash1 = union {ppLineOfEyeLashes(object {ppLowerEyeLash}, ppRightLowerLidArray, ppRightLowerLidNormal, ppLowerLidLashLine, ppLowerLidSegments, ppLowerEyeLashSpacing,-1)}
