/***************************************************************************************************/
/* hairline.inc  - Copyright Chris Bartlett 01 Feb 2004                                            */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/
#ifndef (ppCamera) #declare ppCamera="HairLine"; #end  
#ifndef (ppFace)   #include "ppf1face.inc"       #end

#declare ppHairLine = difference {
  union {
    object {ppFace}
    object {ppFace scale <-1,1,1>}
//  cylinder {<-30,0,0><30,0,0>,10 scale <1,1.2,0.75> pigment {color rgbt <1,1,0,0.7>} translate <0,70,30>}
//  cylinder {<-30,0,0><30,0,0>,10 scale <1,2.5,0.8> pigment {color rgbt <1,1,0,0.7>} translate <0,46,31>}
//  cylinder {<-30,0,0><30,0,0>,20 scale <1,1.2,0.5> pigment {color rgbt <1,1,0,0.7>} translate <0,70,6.5>}
//  cylinder {<0,-16,0><0,16,0>,12 scale 1.2 rotate -z*25 pigment {color rgbt <1,1,0,0.7>} translate <12,105,0>}
//  cone {<0,-12,0>,12,<0,19,0>,26 rotate <-40,0,-65> pigment {color rgbt <1,1,0,0.7>} translate <12,105,0>}
    scale 1.001
  }
  plane {<0,0.85,1>,60} 
  cylinder {<-30,0,0><30,0,0>,10 scale <1,1.2,0.75> translate <0,70,30>} // Around Ear
  cylinder {<-30,0,0><30,0,0>,10 scale <1,2.5,0.8> translate <0,48,32>} // Down from Ear
  cylinder {<-30,0,0><30,0,0>,20 scale <1,1.4,0.75> rotate x*14 translate <0,77,3>}  // Down from Temple
  cone {<0,-12,0>,12,<0,19,0>,26 rotate <-40,0, 65> translate <-12,105,0>} // Up From Temple on Right
  cone {<0,-12,0>,12,<0,19,0>,26 rotate <-40,0,-65> translate < 12,105,0>} // Up From Temple on Left
//  cylinder {<-30,0,0><30,0,0>,15 scale <1,1,0.8> translate <0,102,5>}  // Forehead
}

#if (strcmp(ppCamera,"HairLine")=0)
  camera {
    location <0, 0, -30>
    look_at <0, 0, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  object {ppHairLine rotate -x*90   pigment {color rgb <1,0.8,0.8>} scale 0.05 translate < 0, 0.5,0>}
  object {ppHairLine rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 0.05 translate <-4,-5.5,0>}
  object {ppHairLine rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 0.05 translate < 4, 0.5,0>}
  object {ppHairLine rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 0.05 translate <-4, 0.5,0>}
  object {ppHairLine rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 0.05 translate < 4,-5.5,0>}
  
  cylinder {<-25,0.5,0><25,0.5,0>0.025 pigment {rgb <1,1,0>}}
  cylinder {<-25,-5.5,0><25,-5.5,0>0.025 pigment {rgb <1,1,0>}}
  
  cylinder {< 4,-25,0>< 4,25,0>0.025 pigment {rgb <1,1,0>}}
  cylinder {<-4,-25,0><-4,25,0>0.025 pigment {rgb <1,1,0>}}
   
#end                                                    
