/***************************************************************************************************/
/* hairstyle.inc  - Copyright Chris Bartlett 01 Aug 2004                                           */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/
#ifndef (ppHairStyle) #declare ppHairStyle = 0; #end

#switch (ppHairStyle)
  #case (1)   // Brushed straight back
    #declare ppHairFringeDef = <30,20,-10>;
    #declare ppHairCentre = <0,80,0>;   //   <0,55,20>
    #include "ppshorthair.inc"  
  #break 
  #case (2)   // Long ppHair at top, short underneath
    #ifndef (ppHairNumber) #local ppHairNumberCopy = 6000; #else #local ppHairNumberCopy = ppHairNumber; #end  

    // First generate the Fringe
    #declare ppHairNumber = ppHairNumberCopy/2;   // This gives a number of hairs in the Fringe proportional to a total of 3000 on the whole ppHead 
//    #declare ppHairFringeDef = <150,0,60>;      // Make the Fringe cover the whole of the top of the ppHead (all round)
    // Male Settings
    #if (strcmp(ppGender,"male")=0)
      #declare ppHairFringeDef = <150,0,0>;      // Make the Fringe cover the whole of the top of the ppHead (all round)
      #declare ppHairCentre = <0,110,25>;         // Move the centre back 
      #declare ppHairFringeSplay = 10;
    #else    
      #declare ppHairFringeDef = <150,0,20>;      // Make the Fringe cover part of the top of the ppHead (all round)
      #declare ppHairCentre = <0,100,15>;         // Move the centre back 
      #declare ppHairFringeSplay = 10;
    #end
    #declare ppHairFringeLength = 2;
    #declare ppHairExclude = 1;
    #include "ppshorthair.inc"  
    
    #declare ppHairSection  = object {ppHair};    // Store away the Fringe in a temporary object
    
    // Next generate the Main ppHair
    #declare ppHairNumber = ppHairNumberCopy*1.5; // This gives a number of hairs outside the Fringe proportional to a total of 9000 on the whole ppHead
    #declare ppHairCentre = <0,90,-10>;         // Move the centre is close to the front of the ppHead
    #declare ppHairExclude = 2;
    #include "ppshorthair.inc"   
    
    #declare ppHair = union {object {ppHairSection} object {ppHair}};   // Put the two bits of the ppHair object together
  #break 
  #case (3)    // Mohecan
    #declare ppHairExclude = 1;               // Only use the fringe
    #declare ppHairLineVisible = 1;
    #declare ppHairFringeSplay = 50;
    #declare ppHairFringeDef = <5,-100,200>;
    #declare ppHairCentre = <0,90,10>;
    #include "ppshorthair.inc"  
  #break 
  #case (4)    // Bald
    #declare ppHairExclude=3;
    #declare ppHairLineVisible = 1;
    #include "ppshorthair.inc"  
  #break
  #case (5)   // Short Hair, Long Fringe
    #declare ppHairLength = 0.5;
    #declare ppHairFringeLength = 2;
    #declare ppHairFringeDef = <50,30,0>;
    #declare ppHairCentre = <0,50,15>;
    #declare ppHairLineVisible = 1;
    #include "ppshorthair.inc"  
  #break 
  #case (6)   // Short Wavy Hair, No Fringe
    #declare ppHairLength = 0.5;
    #declare ppHairFringeLength = 2;
    #declare ppHairFringeDef = <0,30,0>;
    #declare ppHairCentre = <0,50,15>;
    #declare ppHairLineVisible = 1;
    #include "ppshortwavyhair.inc"  
  #break 
  #case (7)    // No hair, but color the hairline object so it looks the right color from a distance
    #declare ppHairExclude=3;
    #declare ppHairLineVisible = -1;
    #include "ppshorthair.inc"  
  #break
  #else
  #include "ppshorthair.inc"  
#end











