/***************************************************************************************************/
/* human001.inc  - Copyright Chris Bartlett November 2004                                          */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/

#ifndef(ppCamera)  #declare ppCamera="AnatomyCamera"; #end
#ifndef(POVPerson) #include "povperson.inc" #end     
#ifndef(ppModelPrefix) #declare ppModelPrefix="ppf1"; #end 



    
// This macro is used following use of the ppCrowd or ppFigure macros to undefine the multitude of control variables
// 
// Parameters:
// -----------
// ppCharacterReset  - A flag to indicate whether to reset 'character'  control variables (value = 1 or 0)
// ppStyleReset      - A flag to indicate whether to reset 'Style'      control variables (value = 1 or 0)
// ppClothingReset   - A flag to indicate whether to reset 'Clothing'   control variables (value = 1 or 0)
// ppExpressionReset - A flag to indicate whether to reset 'Expression' control variables (value = 1 or 0)
// ppPoseReset       - A flag to indicate whether to reset 'Pose'       control variables (value = 1 or 0)

#macro ppUndef(ppCharacterReset,ppStyleReset,ppClothingReset,ppExpressionReset,ppPoseReset)
  #if (ppStyleReset)

    #if (strcmp(ppGender,"male")!=0)
      #undef ppLipColour                   // The Transparency defines how much affect the skin colour has on the lip colour  
      #undef ppEyeshadowColour             // More or less any colour you want
      #undef ppEyeshadowExtent            // 0.2 to 1.5     1 is default
      #undef ppBlusherColour               // More or less any colour you want
      #undef ppBlusherExtent              // 0.3 to 1       0.4 is default
      
      #undef ppLashLength                 // 10    to 30 
      #undef ppLashDensity                // 0.5   to 1 
      #undef ppLashThickness              // 0.009 to 0.036 
      #undef ppLashColour                 //
         
      #undef ppEyebrowHairThickness       // 0.009 to 0.036 
      #undef ppEyebrowHairColour          // Yellow
      #undef ppHairThickness              // 0.003 = Thin Hair, 0.009 = Thick Hair (Thin Hair needs more hairs and takes longer)
    #end
                
    #undef ppHairColour                 // Golden
    
    #undef ppHairStyle                  // See hairstyle.inc for valid values
    #undef ppHairNumber                 // 12000 gives good cover, but 1 hour render time. 1000 gives enough for test renders
    #undef ppHairLength
    #undef ppHairFringeLength
    #undef ppHairLineVisible
    #undef ppHairRandomness
    #undef ppHairFringeDef
    #undef ppHairExclude                // 1=Exclude Main Hair, 2=Exclude Fringe, 3=Exclude Both
    #undef ppHairFringeSplay  
    #undef ppHairCentre                 // The logical centre from which hairs are radiate
    #undef ppHairTexture      
        
    // The following settings are used by hairTexture.inc. If hairTexture.inc is not used they are ignored. 
    #ifdef(ppHairLightness) #undef ppHairLightness  #end    // 0.1 = Very Dark, 1 = Very Light  
    
    #ifdef(ppHairHighlightProportion) #undef ppHairHighlightProportion  #end // 0 = No Highlights, 1 = Extensive Highlights 
    #ifdef (ppHairHighlightIntensity) #undef ppHairHighlightIntensity   #end // 0.1 = Subtle, 1 = Blatent 
    #ifdef (ppHairHighlightColour)    #undef ppHairHighlightColour      #end 
    #ifdef (ppBeardColour)            #undef ppBeardColour              #end

  #end
  #if (ppCharacterReset)
    #undef ppSkinDarkness               // 0.7 to 8       1 is default, 2 is more dark
    #undef ppSkinRedness                // 0.9 to 2       1 is not very red, 1.5 is redder  
    #undef ppSkinNoiseGenerator         // See noise_generator in the POV-Ray Help 
    #undef ppSkinTexture                //  
    
    #undef ppEyeColour                  // 1=Blue, 2=Brown, 3=Green
    #undef ppEyeBrightness              // 0.5 = Dark, 1.5 = Bright    
    #undef ppEyePupil                   // 1.35 = dilated (big black bit), 0.35 = constricted (small black bit) 
    
    #undef ppEyePosition                // This needs to match the model prefix below:
    #undef ppModelPrefix              // Eaxh character is modeled using files with this prefix

    #if (strcmp(ppGender,"male")=0)
      #undef ppLipColour                   // The Transparency defines how much affect the skin colour has on the lip colour  
      #undef ppEyeshadowColour             // More or less any colour you want
      #undef ppEyeshadowExtent            // 0.2 to 1.5     1 is default
      #undef ppBlusherColour               // More or less any colour you want
      #undef ppBlusherExtent              // 0.3 to 1       0.4 is default
      
      #undef ppLashLength                 // 10    to 30 
      #undef ppLashDensity                // 0.5   to 1 
      #undef ppLashThickness              // 0.009 to 0.036 
      #undef ppLashColour                 //
         
      #undef ppEyebrowHairThickness       // 0.009 to 0.036 
      #undef ppEyebrowHairColour          // Yellow
      #undef ppHairThickness              // 0.003 = Thin Hair, 0.009 = Thick Hair (Thin Hair needs more hairs and takes longer)
    #end
    #undef ppGender                   // Valid values are 'male' and 'female'

  #end
  #if (ppClothingReset)



  #end
  #if (ppExpressionReset)



  #end
  #if (ppPoseReset)



  #end

#end


// This macro is used to add a series of body parts to the figure matrix. This macro is specific to a particular class of figure (e.g. human001). 
// The objects need to have been defined before this macro is called or the body parts will not be added into the figure matrix. 
//
// Parameters:
// -----------  
// - This macro has no parameters

#macro ppAddBodyParts()
  #ifdef(ppUpperTeeth            ) #declare ppUpperTeethRef             = ppAddBodyPart("ppUpperTeeth",object{ppUpperTeeth            }) #end
  #ifdef(ppLowerTeeth            ) #declare ppLowerTeethRef             = ppAddBodyPart("ppLowerTeeth",object{ppLowerTeeth            }) #end
  #ifdef(ppHair                  ) #declare ppHairRef                   = ppAddBodyPart("ppHair      ",object{ppHair                  }) #end
  #ifdef(ppBeard                 ) #declare ppBeardRef                  = ppAddBodyPart("ppBeard     ",object{ppBeard                 }) #end
                                                                                                                                      
  #ifdef(ppHead                  ) #declare ppHeadRef                   = ppAddBodyPart("ppHead      ",object{ppHead                  }) #end
  #ifdef(ppNeck                  ) #declare ppNeckRef                   = ppAddBodyPart("ppNeck      ",object{ppNeck                  }) #end
  #ifdef(ppChest                 ) #declare ppChestRef                  = ppAddBodyPart("ppChest     ",object{ppChest                 }) #end
  #ifdef(ppAbdomen               ) #declare ppAbdomenRef                = ppAddBodyPart("ppAbdomen   ",object{ppAbdomen               }) #end
  #ifdef(ppHips                  ) #declare ppHipRef                    = ppAddBodyPart("ppHips      ",object{ppHips                  }) #end

  // Set any Left handed body parts, defaulting the parts to be the mirror of any Right handed body parts
  #ifdef(ppLeftLips              ) #declare ppLeftLipsRef               = ppAddBodyPart("ppLeftLips              ",object{ppLeftLips              }) #else #ifdef(ppRightLips              ) #declare ppLeftLipsRef               = ppAddBodyPart("ppLeftLips              ",object{ppRightLips               scale <-1,1,1>}) #end #end                         
  #ifdef(ppLeftUpperEyeLid       ) #declare ppLeftUpperEyeLidRef        = ppAddBodyPart("ppLeftUpperEyeLid       ",object{ppLeftUpperEyeLid       }) #else #ifdef(ppRightUpperEyeLid       ) #declare ppLeftUpperEyeLidRef        = ppAddBodyPart("ppLeftUpperEyeLid       ",object{ppRightUpperEyeLid        scale <-1,1,1>}) #end #end                         
  #ifdef(ppLeftLowerEyeLid       ) #declare ppLeftLowerEyeLidRef        = ppAddBodyPart("ppLeftLowerEyeLid       ",object{ppLeftLowerEyeLid       }) #else #ifdef(ppRightLowerEyeLid       ) #declare ppLeftLowerEyeLidRef        = ppAddBodyPart("ppLeftLowerEyeLid       ",object{ppRightLowerEyeLid        scale <-1,1,1>}) #end #end                         
  #ifdef(ppLeftEye               ) #declare ppLeftEyeRef                = ppAddBodyPart("ppLeftEye               ",object{ppLeftEye               }) #else #ifdef(ppRightEye               ) #declare ppLeftEyeRef                = ppAddBodyPart("ppLeftEye               ",object{ppRightEye                scale <-1,1,1>}) #end #end
  #ifdef(ppLeftUpperLash         ) #declare ppLeftUpperLashRef          = ppAddBodyPart("ppLeftUpperLash         ",object{ppLeftUpperLash         }) #else #ifdef(ppRightUpperLash         ) #declare ppLeftUpperLashRef          = ppAddBodyPart("ppLeftUpperLash         ",object{ppRightUpperLash          scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLowerLash         ) #declare ppLeftLowerLashRef          = ppAddBodyPart("ppLeftLowerLash         ",object{ppLeftLowerLash         }) #else #ifdef(ppRightLowerLash         ) #declare ppLeftLowerLashRef          = ppAddBodyPart("ppLeftLowerLash         ",object{ppRightLowerLash          scale <-1,1,1>}) #end #end
  #ifdef(ppLeftEyeBrow           ) #declare ppLeftEyeBrowRef            = ppAddBodyPart("ppLeftEyeBrow           ",object{ppLeftEyeBrow           }) #else #ifdef(ppRightEyeBrow           ) #declare ppLeftEyeBrowRef            = ppAddBodyPart("ppLeftEyeBrow           ",object{ppRightEyeBrow            scale <-1,1,1>}) #end #end
  #ifdef(ppLeftEar               ) #declare ppLeftEarRef                = ppAddBodyPart("ppLeftEar               ",object{ppLeftEar               }) #else #ifdef(ppRightEar               ) #declare ppLeftEarRef                = ppAddBodyPart("ppLeftEar               ",object{ppRightEar                scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                          
  #ifdef(ppLeftShoulder          ) #declare ppLeftShoulderRef           = ppAddBodyPart("ppLeftShoulder          ",object{ppLeftShoulder          }) #else #ifdef(ppRightShoulder          ) #declare ppLeftShoulderRef           = ppAddBodyPart("ppLeftShoulder          ",object{ppRightShoulder           scale <-1,1,1>}) #end #end
  #ifdef(ppLeftUpperArm          ) #declare ppLeftUpperArmRef           = ppAddBodyPart("ppLeftUpperArm          ",object{ppLeftUpperArm          }) #else #ifdef(ppRightUpperArm          ) #declare ppLeftUpperArmRef           = ppAddBodyPart("ppLeftUpperArm          ",object{ppRightUpperArm           scale <-1,1,1>}) #end #end
  #ifdef(ppLeftForeArm           ) #declare ppLeftForeArmRef            = ppAddBodyPart("ppLeftForeArm           ",object{ppLeftForeArm           }) #else #ifdef(ppRightForeArm           ) #declare ppLeftForeArmRef            = ppAddBodyPart("ppLeftForeArm           ",object{ppRightForeArm            scale <-1,1,1>}) #end #end
  #ifdef(ppLeftPalm              ) #declare ppLeftPalmRef               = ppAddBodyPart("ppLeftPalm              ",object{ppLeftPalm              }) #else #ifdef(ppRightPalm              ) #declare ppLeftPalmRef               = ppAddBodyPart("ppLeftPalm              ",object{ppRightPalm               scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThumbBase         ) #declare ppLeftThumbBaseRef          = ppAddBodyPart("ppLeftThumbBase         ",object{ppLeftThumbBase         }) #else #ifdef(ppRightThumbBase         ) #declare ppLeftThumbBaseRef          = ppAddBodyPart("ppLeftThumbBase         ",object{ppRightThumbBase          scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThumbMiddle       ) #declare ppLeftThumbMiddleRef        = ppAddBodyPart("ppLeftThumbMiddle       ",object{ppLeftThumbMiddle       }) #else #ifdef(ppRightThumbMiddle       ) #declare ppLeftThumbMiddleRef        = ppAddBodyPart("ppLeftThumbMiddle       ",object{ppRightThumbMiddle        scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThumbTip          ) #declare ppLeftThumbTipRef           = ppAddBodyPart("ppLeftThumbTip          ",object{ppLeftThumbTip          }) #else #ifdef(ppRightThumbTip          ) #declare ppLeftThumbTipRef           = ppAddBodyPart("ppLeftThumbTip          ",object{ppRightThumbTip           scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFirstFingerBase   ) #declare ppLeftFirstFingerBaseRef    = ppAddBodyPart("ppLeftFirstFingerBase   ",object{ppLeftFirstFingerBase   }) #else #ifdef(ppRightFirstFingerBase   ) #declare ppLeftFirstFingerBaseRef    = ppAddBodyPart("ppLeftFirstFingerBase   ",object{ppRightFirstFingerBase    scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFirstFingerMiddle ) #declare ppLeftFirstFingerMiddleRef  = ppAddBodyPart("ppLeftFirstFingerMiddle ",object{ppLeftFirstFingerMiddle }) #else #ifdef(ppRightFirstFingerMiddle ) #declare ppLeftFirstFingerMiddleRef  = ppAddBodyPart("ppLeftFirstFingerMiddle ",object{ppRightFirstFingerMiddle  scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFirstFingerTip    ) #declare ppLeftFirstFingerTipRef     = ppAddBodyPart("ppLeftFirstFingerTip    ",object{ppLeftFirstFingerTip    }) #else #ifdef(ppRightFirstFingerTip    ) #declare ppLeftFirstFingerTipRef     = ppAddBodyPart("ppLeftFirstFingerTip    ",object{ppRightFirstFingerTip     scale <-1,1,1>}) #end #end
  #ifdef(ppLeftMiddleFingerBase  ) #declare ppLeftMiddleFingerBaseRef   = ppAddBodyPart("ppLeftMiddleFingerBase  ",object{ppLeftMiddleFingerBase  }) #else #ifdef(ppRightMiddleFingerBase  ) #declare ppLeftMiddleFingerBaseRef   = ppAddBodyPart("ppLeftMiddleFingerBase  ",object{ppRightMiddleFingerBase   scale <-1,1,1>}) #end #end
  #ifdef(ppLeftMiddleFingerMiddle) #declare ppLeftMiddleFingerMiddleRef = ppAddBodyPart("ppLeftMiddleFingerMiddle",object{ppLeftMiddleFingerMiddle}) #else #ifdef(ppRightMiddleFingerMiddle) #declare ppLeftMiddleFingerMiddleRef = ppAddBodyPart("ppLeftMiddleFingerMiddle",object{ppRightMiddleFingerMiddle scale <-1,1,1>}) #end #end
  #ifdef(ppLeftMiddleFingerTip   ) #declare ppLeftMiddleFingerTipRef    = ppAddBodyPart("ppLeftMiddleFingerTip   ",object{ppLeftMiddleFingerTip   }) #else #ifdef(ppRightMiddleFingerTip   ) #declare ppLeftMiddleFingerTipRef    = ppAddBodyPart("ppLeftMiddleFingerTip   ",object{ppRightMiddleFingerTip    scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThirdFingerBase   ) #declare ppLeftThirdFingerBaseRef    = ppAddBodyPart("ppLeftThirdFingerBase   ",object{ppLeftThirdFingerBase   }) #else #ifdef(ppRightThirdFingerBase   ) #declare ppLeftThirdFingerBaseRef    = ppAddBodyPart("ppLeftThirdFingerBase   ",object{ppRightThirdFingerBase    scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThirdFingerMiddle ) #declare ppLeftThirdFingerMiddleRef  = ppAddBodyPart("ppLeftThirdFingerMiddle ",object{ppLeftThirdFingerMiddle }) #else #ifdef(ppRightThirdFingerMiddle ) #declare ppLeftThirdFingerMiddleRef  = ppAddBodyPart("ppLeftThirdFingerMiddle ",object{ppRightThirdFingerMiddle  scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThirdFingerTip    ) #declare ppLeftThirdFingerTipRef     = ppAddBodyPart("ppLeftThirdFingerTip    ",object{ppLeftThirdFingerTip    }) #else #ifdef(ppRightThirdFingerTip    ) #declare ppLeftThirdFingerTipRef     = ppAddBodyPart("ppLeftThirdFingerTip    ",object{ppRightThirdFingerTip     scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLittleFingerBase  ) #declare ppLeftLittleFingerBaseRef   = ppAddBodyPart("ppLeftLittleFingerBase  ",object{ppLeftLittleFingerBase  }) #else #ifdef(ppRightLittleFingerBase  ) #declare ppLeftLittleFingerBaseRef   = ppAddBodyPart("ppLeftLittleFingerBase  ",object{ppRightLittleFingerBase   scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLittleFingerMiddle) #declare ppLeftLittleFingerMiddleRef = ppAddBodyPart("ppLeftLittleFingerMiddle",object{ppLeftLittleFingerMiddle}) #else #ifdef(ppRightLittleFingerMiddle) #declare ppLeftLittleFingerMiddleRef = ppAddBodyPart("ppLeftLittleFingerMiddle",object{ppRightLittleFingerMiddle scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLittleFingerTip   ) #declare ppLeftLittleFingerTipRef    = ppAddBodyPart("ppLeftLittleFingerTip   ",object{ppLeftLittleFingerTip   }) #else #ifdef(ppRightLittleFingerTip   ) #declare ppLeftLittleFingerTipRef    = ppAddBodyPart("ppLeftLittleFingerTip   ",object{ppRightLittleFingerTip    scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                          
  #ifdef(ppLeftThumbNail         ) #declare ppLeftThumbNailRef          = ppAddBodyPart("ppLeftThumbNail         ",object{ppLeftThumbNail         }) #else #ifdef(ppRightThumbNail         ) #declare ppLeftThumbNailRef          = ppAddBodyPart("ppLeftThumbNail         ",object{ppRightThumbNail          scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFirstFingerNail   ) #declare ppLeftFirstFingerNailRef    = ppAddBodyPart("ppLeftFirstFingerNail   ",object{ppLeftFirstFingerNail   }) #else #ifdef(ppRightFirstFingerNail   ) #declare ppLeftFirstFingerNailRef    = ppAddBodyPart("ppLeftFirstFingerNail   ",object{ppRightFirstFingerNail    scale <-1,1,1>}) #end #end
  #ifdef(ppLeftMiddleFingerNail  ) #declare ppLeftMiddleFingerNailRef   = ppAddBodyPart("ppLeftMiddleFingerNail  ",object{ppLeftMiddleFingerNail  }) #else #ifdef(ppRightMiddleFingerNail  ) #declare ppLeftMiddleFingerNailRef   = ppAddBodyPart("ppLeftMiddleFingerNail  ",object{ppRightMiddleFingerNail   scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThirdFingerNail   ) #declare ppLeftThirdFingerNailRef    = ppAddBodyPart("ppLeftThirdFingerNail   ",object{ppLeftThirdFingerNail   }) #else #ifdef(ppRightThirdFingerNail   ) #declare ppLeftThirdFingerNailRef    = ppAddBodyPart("ppLeftThirdFingerNail   ",object{ppRightThirdFingerNail    scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLittleFingerNail  ) #declare ppLeftLittleFingerNailRef   = ppAddBodyPart("ppLeftLittleFingerNail  ",object{ppLeftLittleFingerNail  }) #else #ifdef(ppRightLittleFingerNail  ) #declare ppLeftLittleFingerNailRef   = ppAddBodyPart("ppLeftLittleFingerNail  ",object{ppRightLittleFingerNail   scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                          
  #ifdef(ppLeftThigh             ) #declare ppLeftThighRef              = ppAddBodyPart("ppLeftThigh             ",object{ppLeftThigh             }) #else #ifdef(ppRightThigh             ) #declare ppLeftThighRef              = ppAddBodyPart("ppLeftThigh             ",object{ppRightThigh              scale <-1,1,1>}) #end #end
  #ifdef(ppLeftCalf              ) #declare ppLeftCalfRef               = ppAddBodyPart("ppLeftCalf              ",object{ppLeftCalf              }) #else #ifdef(ppRightCalf              ) #declare ppLeftCalfRef               = ppAddBodyPart("ppLeftCalf              ",object{ppRightCalf               scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFoot              ) #declare ppLeftFootRef               = ppAddBodyPart("ppLeftFoot              ",object{ppLeftFoot              }) #else #ifdef(ppRightFoot              ) #declare ppLeftFootRef               = ppAddBodyPart("ppLeftFoot              ",object{ppRightFoot               scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                          
  #ifdef(ppLeftBigToeBase        ) #declare ppLeftBigToeBaseRef         = ppAddBodyPart("ppLeftBigToeBase        ",object{ppLeftBigToeBase        }) #else #ifdef(ppRightBigToeBase        ) #declare ppLeftBigToeBaseRef         = ppAddBodyPart("ppLeftBigToeBase        ",object{ppRightBigToeBase         scale <-1,1,1>}) #end #end
  #ifdef(ppLeftBigToeTip         ) #declare ppLeftBigToeTipRef          = ppAddBodyPart("ppLeftBigToeTip         ",object{ppLeftBigToeTip         }) #else #ifdef(ppRightBigToeTip         ) #declare ppLeftBigToeTipRef          = ppAddBodyPart("ppLeftBigToeTip         ",object{ppRightBigToeTip          scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFirstToeBase      ) #declare ppLeftFirstToeBaseRef       = ppAddBodyPart("ppLeftFirstToeBase      ",object{ppLeftFirstToeBase      }) #else #ifdef(ppRightFirstToeBase      ) #declare ppLeftFirstToeBaseRef       = ppAddBodyPart("ppLeftFirstToeBase      ",object{ppRightFirstToeBase       scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFirstToeMiddle    ) #declare ppLeftFirstToeMiddleRef     = ppAddBodyPart("ppLeftFirstToeMiddle    ",object{ppLeftFirstToeMiddle    }) #else #ifdef(ppRightFirstToeMiddle    ) #declare ppLeftFirstToeMiddleRef     = ppAddBodyPart("ppLeftFirstToeMiddle    ",object{ppRightFirstToeMiddle     scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFirstToeTip       ) #declare ppLeftFirstToeTipRef        = ppAddBodyPart("ppLeftFirstToeTip       ",object{ppLeftFirstToeTip       }) #else #ifdef(ppRightFirstToeTip       ) #declare ppLeftFirstToeTipRef        = ppAddBodyPart("ppLeftFirstToeTip       ",object{ppRightFirstToeTip        scale <-1,1,1>}) #end #end
  #ifdef(ppLeftMiddleToeBase     ) #declare ppLeftMiddleToeBaseRef      = ppAddBodyPart("ppLeftMiddleToeBase     ",object{ppLeftMiddleToeBase     }) #else #ifdef(ppRightMiddleToeBase     ) #declare ppLeftMiddleToeBaseRef      = ppAddBodyPart("ppLeftMiddleToeBase     ",object{ppRightMiddleToeBase      scale <-1,1,1>}) #end #end
  #ifdef(ppLeftMiddleToeMiddle   ) #declare ppLeftMiddleToeMiddleRef    = ppAddBodyPart("ppLeftMiddleToeMiddle   ",object{ppLeftMiddleToeMiddle   }) #else #ifdef(ppRightMiddleToeMiddle   ) #declare ppLeftMiddleToeMiddleRef    = ppAddBodyPart("ppLeftMiddleToeMiddle   ",object{ppRightMiddleToeMiddle    scale <-1,1,1>}) #end #end
  #ifdef(ppLeftMiddleToeTip      ) #declare ppLeftMiddleToeTipRef       = ppAddBodyPart("ppLeftMiddleToeTip      ",object{ppLeftMiddleToeTip      }) #else #ifdef(ppRightMiddleToeTip      ) #declare ppLeftMiddleToeTipRef       = ppAddBodyPart("ppLeftMiddleToeTip      ",object{ppRightMiddleToeTip       scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThirdToeBase      ) #declare ppLeftThirdToeBaseRef       = ppAddBodyPart("ppLeftThirdToeBase      ",object{ppLeftThirdToeBase      }) #else #ifdef(ppRightThirdToeBase      ) #declare ppLeftThirdToeBaseRef       = ppAddBodyPart("ppLeftThirdToeBase      ",object{ppRightThirdToeBase       scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThirdToeMiddle    ) #declare ppLeftThirdToeMiddleRef     = ppAddBodyPart("ppLeftThirdToeMiddle    ",object{ppLeftThirdToeMiddle    }) #else #ifdef(ppRightThirdToeMiddle    ) #declare ppLeftThirdToeMiddleRef     = ppAddBodyPart("ppLeftThirdToeMiddle    ",object{ppRightThirdToeMiddle     scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThirdToeTip       ) #declare ppLeftThirdToeTipRef        = ppAddBodyPart("ppLeftThirdToeTip       ",object{ppLeftThirdToeTip       }) #else #ifdef(ppRightThirdToeTip       ) #declare ppLeftThirdToeTipRef        = ppAddBodyPart("ppLeftThirdToeTip       ",object{ppRightThirdToeTip        scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLittleToeBase     ) #declare ppLeftLittleToeBaseRef      = ppAddBodyPart("ppLeftLittleToeBase     ",object{ppLeftLittleToeBase     }) #else #ifdef(ppRightLittleToeBase     ) #declare ppLeftLittleToeBaseRef      = ppAddBodyPart("ppLeftLittleToeBase     ",object{ppRightLittleToeBase      scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLittleToeMiddle   ) #declare ppLeftLittleToeMiddleRef    = ppAddBodyPart("ppLeftLittleToeMiddle   ",object{ppLeftLittleToeMiddle   }) #else #ifdef(ppRightLittleToeMiddle   ) #declare ppLeftLittleToeMiddleRef    = ppAddBodyPart("ppLeftLittleToeMiddle   ",object{ppRightLittleToeMiddle    scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLittleToeTip      ) #declare ppLeftLittleToeTipRef       = ppAddBodyPart("ppLeftLittleToeTip      ",object{ppLeftLittleToeTip      }) #else #ifdef(ppRightLittleToeTip      ) #declare ppLeftLittleToeTipRef       = ppAddBodyPart("ppLeftLittleToeTip      ",object{ppRightLittleToeTip       scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                          
  #ifdef(ppLeftBigToeNail        ) #declare ppLeftBigToeNailRef         = ppAddBodyPart("ppLeftBigToeNail        ",object{ppLeftBigToeNail        }) #else #ifdef(ppRightBigToeNail        ) #declare ppLeftBigToeNailRef         = ppAddBodyPart("ppLeftBigToeNail        ",object{ppRightBigToeNail         scale <-1,1,1>}) #end #end
  #ifdef(ppLeftFirstToeNail      ) #declare ppLeftFirstToeNailRef       = ppAddBodyPart("ppLeftFirstToeNail      ",object{ppLeftFirstToeNail      }) #else #ifdef(ppRightFirstToeNail      ) #declare ppLeftFirstToeNailRef       = ppAddBodyPart("ppLeftFirstToeNail      ",object{ppRightFirstToeNail       scale <-1,1,1>}) #end #end
  #ifdef(ppLeftMiddleToeNail     ) #declare ppLeftMiddleToeNailRef      = ppAddBodyPart("ppLeftMiddleToeNail     ",object{ppLeftMiddleToeNail     }) #else #ifdef(ppRightMiddleToeNail     ) #declare ppLeftMiddleToeNailRef      = ppAddBodyPart("ppLeftMiddleToeNail     ",object{ppRightMiddleToeNail      scale <-1,1,1>}) #end #end
  #ifdef(ppLeftThirdToeNail      ) #declare ppLeftThirdToeNailRef       = ppAddBodyPart("ppLeftThirdToeNail      ",object{ppLeftThirdToeNail      }) #else #ifdef(ppRightThirdToeNail      ) #declare ppLeftThirdToeNailRef       = ppAddBodyPart("ppLeftThirdToeNail      ",object{ppRightThirdToeNail       scale <-1,1,1>}) #end #end
  #ifdef(ppLeftLittleToeNail     ) #declare ppLeftLittleToeNailRef      = ppAddBodyPart("ppLeftLittleToeNail     ",object{ppLeftLittleToeNail     }) #else #ifdef(ppRightLittleToeNail     ) #declare ppLeftLittleToeNailRef      = ppAddBodyPart("ppLeftLittleToeNail     ",object{ppRightLittleToeNail      scale <-1,1,1>}) #end #end


  // Set any right handed body parts, defaulting the parts to be the mirror of any left handed body parts
  #ifdef(ppRightLips              ) #declare ppRightLipsRef               = ppAddBodyPart("ppRightLips              ",object{ppRightLips              }) #else #ifdef(ppLeftLips              ) #declare ppRightLipsRef               = ppAddBodyPart("ppRightLips              ",object{ppLeftLips               scale <-1,1,1>}) #end #end                         
  #ifdef(ppRightUpperEyeLid       ) #declare ppRightUpperEyeLidRef        = ppAddBodyPart("ppRightUpperEyeLid       ",object{ppRightUpperEyeLid       }) #else #ifdef(ppLeftUpperEyeLid       ) #declare ppRightUpperEyeLidRef        = ppAddBodyPart("ppRightUpperEyeLid       ",object{ppLeftUpperEyeLid        scale <-1,1,1>}) #end #end                         
  #ifdef(ppRightLowerEyeLid       ) #declare ppRightLowerEyeLidRef        = ppAddBodyPart("ppRightLowerEyeLid       ",object{ppRightLowerEyeLid       }) #else #ifdef(ppLeftLowerEyeLid       ) #declare ppRightLowerEyeLidRef        = ppAddBodyPart("ppRightLowerEyeLid       ",object{ppLeftLowerEyeLid        scale <-1,1,1>}) #end #end                         
  #ifdef(ppRightEye               ) #declare ppRightEyeRef                = ppAddBodyPart("ppRightEye               ",object{ppRightEye               }) #else #ifdef(ppLeftEye               ) #declare ppRightEyeRef                = ppAddBodyPart("ppRightEye               ",object{ppLeftEye                scale <-1,1,1>}) #end #end
  #ifdef(ppRightUpperLash         ) #declare ppRightUpperLashRef          = ppAddBodyPart("ppRightUpperLash         ",object{ppRightUpperLash         }) #else #ifdef(ppLeftUpperLash         ) #declare ppRightUpperLashRef          = ppAddBodyPart("ppRightUpperLash         ",object{ppLeftUpperLash          scale <-1,1,1>}) #end #end
  #ifdef(ppRightLowerLash         ) #declare ppRightLowerLashRef          = ppAddBodyPart("ppRightLowerLash         ",object{ppRightLowerLash         }) #else #ifdef(ppLeftLowerLash         ) #declare ppRightLowerLashRef          = ppAddBodyPart("ppRightLowerLash         ",object{ppLeftLowerLash          scale <-1,1,1>}) #end #end
  #ifdef(ppRightEyeBrow           ) #declare ppRightEyeBrowRef            = ppAddBodyPart("ppRightEyeBrow           ",object{ppRightEyeBrow           }) #else #ifdef(ppLeftEyeBrow           ) #declare ppRightEyeBrowRef            = ppAddBodyPart("ppRightEyeBrow           ",object{ppLeftEyeBrow            scale <-1,1,1>}) #end #end
  #ifdef(ppRightEar               ) #declare ppRightEarRef                = ppAddBodyPart("ppRightEar               ",object{ppRightEar               }) #else #ifdef(ppLeftEar               ) #declare ppRightEarRef                = ppAddBodyPart("ppRightEar               ",object{ppLeftEar                scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                            
  #ifdef(ppRightShoulder          ) #declare ppRightShoulderRef           = ppAddBodyPart("ppRightShoulder          ",object{ppRightShoulder          }) #else #ifdef(ppLeftShoulder          ) #declare ppRightShoulderRef           = ppAddBodyPart("ppRightShoulder          ",object{ppLeftShoulder           scale <-1,1,1>}) #end #end
  #ifdef(ppRightUpperArm          ) #declare ppRightUpperArmRef           = ppAddBodyPart("ppRightUpperArm          ",object{ppRightUpperArm          }) #else #ifdef(ppLeftUpperArm          ) #declare ppRightUpperArmRef           = ppAddBodyPart("ppRightUpperArm          ",object{ppLeftUpperArm           scale <-1,1,1>}) #end #end
  #ifdef(ppRightForeArm           ) #declare ppRightForeArmRef            = ppAddBodyPart("ppRightForeArm           ",object{ppRightForeArm           }) #else #ifdef(ppLeftForeArm           ) #declare ppRightForeArmRef            = ppAddBodyPart("ppRightForeArm           ",object{ppLeftForeArm            scale <-1,1,1>}) #end #end
  #ifdef(ppRightPalm              ) #declare ppRightPalmRef               = ppAddBodyPart("ppRightPalm              ",object{ppRightPalm              }) #else #ifdef(ppLeftPalm              ) #declare ppRightPalmRef               = ppAddBodyPart("ppRightPalm              ",object{ppLeftPalm               scale <-1,1,1>}) #end #end
  #ifdef(ppRightThumbBase         ) #declare ppRightThumbBaseRef          = ppAddBodyPart("ppRightThumbBase         ",object{ppRightThumbBase         }) #else #ifdef(ppLeftThumbBase         ) #declare ppRightThumbBaseRef          = ppAddBodyPart("ppRightThumbBase         ",object{ppLeftThumbBase          scale <-1,1,1>}) #end #end
  #ifdef(ppRightThumbMiddle       ) #declare ppRightThumbMiddleRef        = ppAddBodyPart("ppRightThumbMiddle       ",object{ppRightThumbMiddle       }) #else #ifdef(ppLeftThumbMiddle       ) #declare ppRightThumbMiddleRef        = ppAddBodyPart("ppRightThumbMiddle       ",object{ppLeftThumbMiddle        scale <-1,1,1>}) #end #end
  #ifdef(ppRightThumbTip          ) #declare ppRightThumbTipRef           = ppAddBodyPart("ppRightThumbTip          ",object{ppRightThumbTip          }) #else #ifdef(ppLeftThumbTip          ) #declare ppRightThumbTipRef           = ppAddBodyPart("ppRightThumbTip          ",object{ppLeftThumbTip           scale <-1,1,1>}) #end #end
  #ifdef(ppRightFirstFingerBase   ) #declare ppRightFirstFingerBaseRef    = ppAddBodyPart("ppRightFirstFingerBase   ",object{ppRightFirstFingerBase   }) #else #ifdef(ppLeftFirstFingerBase   ) #declare ppRightFirstFingerBaseRef    = ppAddBodyPart("ppRightFirstFingerBase   ",object{ppLeftFirstFingerBase    scale <-1,1,1>}) #end #end
  #ifdef(ppRightFirstFingerMiddle ) #declare ppRightFirstFingerMiddleRef  = ppAddBodyPart("ppRightFirstFingerMiddle ",object{ppRightFirstFingerMiddle }) #else #ifdef(ppLeftFirstFingerMiddle ) #declare ppRightFirstFingerMiddleRef  = ppAddBodyPart("ppRightFirstFingerMiddle ",object{ppLeftFirstFingerMiddle  scale <-1,1,1>}) #end #end
  #ifdef(ppRightFirstFingerTip    ) #declare ppRightFirstFingerTipRef     = ppAddBodyPart("ppRightFirstFingerTip    ",object{ppRightFirstFingerTip    }) #else #ifdef(ppLeftFirstFingerTip    ) #declare ppRightFirstFingerTipRef     = ppAddBodyPart("ppRightFirstFingerTip    ",object{ppLeftFirstFingerTip     scale <-1,1,1>}) #end #end
  #ifdef(ppRightMiddleFingerBase  ) #declare ppRightMiddleFingerBaseRef   = ppAddBodyPart("ppRightMiddleFingerBase  ",object{ppRightMiddleFingerBase  }) #else #ifdef(ppLeftMiddleFingerBase  ) #declare ppRightMiddleFingerBaseRef   = ppAddBodyPart("ppRightMiddleFingerBase  ",object{ppLeftMiddleFingerBase   scale <-1,1,1>}) #end #end
  #ifdef(ppRightMiddleFingerMiddle) #declare ppRightMiddleFingerMiddleRef = ppAddBodyPart("ppRightMiddleFingerMiddle",object{ppRightMiddleFingerMiddle}) #else #ifdef(ppLeftMiddleFingerMiddle) #declare ppRightMiddleFingerMiddleRef = ppAddBodyPart("ppRightMiddleFingerMiddle",object{ppLeftMiddleFingerMiddle scale <-1,1,1>}) #end #end
  #ifdef(ppRightMiddleFingerTip   ) #declare ppRightMiddleFingerTipRef    = ppAddBodyPart("ppRightMiddleFingerTip   ",object{ppRightMiddleFingerTip   }) #else #ifdef(ppLeftMiddleFingerTip   ) #declare ppRightMiddleFingerTipRef    = ppAddBodyPart("ppRightMiddleFingerTip   ",object{ppLeftMiddleFingerTip    scale <-1,1,1>}) #end #end
  #ifdef(ppRightThirdFingerBase   ) #declare ppRightThirdFingerBaseRef    = ppAddBodyPart("ppRightThirdFingerBase   ",object{ppRightThirdFingerBase   }) #else #ifdef(ppLeftThirdFingerBase   ) #declare ppRightThirdFingerBaseRef    = ppAddBodyPart("ppRightThirdFingerBase   ",object{ppLeftThirdFingerBase    scale <-1,1,1>}) #end #end
  #ifdef(ppRightThirdFingerMiddle ) #declare ppRightThirdFingerMiddleRef  = ppAddBodyPart("ppRightThirdFingerMiddle ",object{ppRightThirdFingerMiddle }) #else #ifdef(ppLeftThirdFingerMiddle ) #declare ppRightThirdFingerMiddleRef  = ppAddBodyPart("ppRightThirdFingerMiddle ",object{ppLeftThirdFingerMiddle  scale <-1,1,1>}) #end #end
  #ifdef(ppRightThirdFingerTip    ) #declare ppRightThirdFingerTipRef     = ppAddBodyPart("ppRightThirdFingerTip    ",object{ppRightThirdFingerTip    }) #else #ifdef(ppLeftThirdFingerTip    ) #declare ppRightThirdFingerTipRef     = ppAddBodyPart("ppRightThirdFingerTip    ",object{ppLeftThirdFingerTip     scale <-1,1,1>}) #end #end
  #ifdef(ppRightLittleFingerBase  ) #declare ppRightLittleFingerBaseRef   = ppAddBodyPart("ppRightLittleFingerBase  ",object{ppRightLittleFingerBase  }) #else #ifdef(ppLeftLittleFingerBase  ) #declare ppRightLittleFingerBaseRef   = ppAddBodyPart("ppRightLittleFingerBase  ",object{ppLeftLittleFingerBase   scale <-1,1,1>}) #end #end
  #ifdef(ppRightLittleFingerMiddle) #declare ppRightLittleFingerMiddleRef = ppAddBodyPart("ppRightLittleFingerMiddle",object{ppRightLittleFingerMiddle}) #else #ifdef(ppLeftLittleFingerMiddle) #declare ppRightLittleFingerMiddleRef = ppAddBodyPart("ppRightLittleFingerMiddle",object{ppLeftLittleFingerMiddle scale <-1,1,1>}) #end #end
  #ifdef(ppRightLittleFingerTip   ) #declare ppRightLittleFingerTipRef    = ppAddBodyPart("ppRightLittleFingerTip   ",object{ppRightLittleFingerTip   }) #else #ifdef(ppLeftLittleFingerTip   ) #declare ppRightLittleFingerTipRef    = ppAddBodyPart("ppRightLittleFingerTip   ",object{ppLeftLittleFingerTip    scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                            
  #ifdef(ppRightThumbNail         ) #declare ppRightThumbNailRef          = ppAddBodyPart("ppRightThumbNail         ",object{ppRightThumbNail         }) #else #ifdef(ppLeftThumbNail         ) #declare ppRightThumbNailRef          = ppAddBodyPart("ppRightThumbNail         ",object{ppLeftThumbNail          scale <-1,1,1>}) #end #end
  #ifdef(ppRightFirstFingerNail   ) #declare ppRightFirstFingerNailRef    = ppAddBodyPart("ppRightFirstFingerNail   ",object{ppRightFirstFingerNail   }) #else #ifdef(ppLeftFirstFingerNail   ) #declare ppRightFirstFingerNailRef    = ppAddBodyPart("ppRightFirstFingerNail   ",object{ppLeftFirstFingerNail    scale <-1,1,1>}) #end #end
  #ifdef(ppRightMiddleFingerNail  ) #declare ppRightMiddleFingerNailRef   = ppAddBodyPart("ppRightMiddleFingerNail  ",object{ppRightMiddleFingerNail  }) #else #ifdef(ppLeftMiddleFingerNail  ) #declare ppRightMiddleFingerNailRef   = ppAddBodyPart("ppRightMiddleFingerNail  ",object{ppLeftMiddleFingerNail   scale <-1,1,1>}) #end #end
  #ifdef(ppRightThirdFingerNail   ) #declare ppRightThirdFingerNailRef    = ppAddBodyPart("ppRightThirdFingerNail   ",object{ppRightThirdFingerNail   }) #else #ifdef(ppLeftThirdFingerNail   ) #declare ppRightThirdFingerNailRef    = ppAddBodyPart("ppRightThirdFingerNail   ",object{ppLeftThirdFingerNail    scale <-1,1,1>}) #end #end
  #ifdef(ppRightLittleFingerNail  ) #declare ppRightLittleFingerNailRef   = ppAddBodyPart("ppRightLittleFingerNail  ",object{ppRightLittleFingerNail  }) #else #ifdef(ppLeftLittleFingerNail  ) #declare ppRightLittleFingerNailRef   = ppAddBodyPart("ppRightLittleFingerNail  ",object{ppLeftLittleFingerNail   scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                            
  #ifdef(ppRightThigh             ) #declare ppRightThighRef              = ppAddBodyPart("ppRightThigh             ",object{ppRightThigh             }) #else #ifdef(ppLeftThigh             ) #declare ppRightThighRef              = ppAddBodyPart("ppRightThigh             ",object{ppLeftThigh              scale <-1,1,1>}) #end #end
  #ifdef(ppRightCalf              ) #declare ppRightCalfRef               = ppAddBodyPart("ppRightCalf              ",object{ppRightCalf              }) #else #ifdef(ppLeftCalf              ) #declare ppRightCalfRef               = ppAddBodyPart("ppRightCalf              ",object{ppLeftCalf               scale <-1,1,1>}) #end #end
  #ifdef(ppRightFoot              ) #declare ppRightFootRef               = ppAddBodyPart("ppRightFoot              ",object{ppRightFoot              }) #else #ifdef(ppLeftFoot              ) #declare ppRightFootRef               = ppAddBodyPart("ppRightFoot              ",object{ppLeftFoot               scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                            
  #ifdef(ppRightBigToeBase        ) #declare ppRightBigToeBaseRef         = ppAddBodyPart("ppRightBigToeBase        ",object{ppRightBigToeBase        }) #else #ifdef(ppLeftBigToeBase        ) #declare ppRightBigToeBaseRef         = ppAddBodyPart("ppRightBigToeBase        ",object{ppLeftBigToeBase         scale <-1,1,1>}) #end #end
  #ifdef(ppRightBigToeTip         ) #declare ppRightBigToeTipRef          = ppAddBodyPart("ppRightBigToeTip         ",object{ppRightBigToeTip         }) #else #ifdef(ppLeftBigToeTip         ) #declare ppRightBigToeTipRef          = ppAddBodyPart("ppRightBigToeTip         ",object{ppLeftBigToeTip          scale <-1,1,1>}) #end #end
  #ifdef(ppRightFirstToeBase      ) #declare ppRightFirstToeBaseRef       = ppAddBodyPart("ppRightFirstToeBase      ",object{ppRightFirstToeBase      }) #else #ifdef(ppLeftFirstToeBase      ) #declare ppRightFirstToeBaseRef       = ppAddBodyPart("ppRightFirstToeBase      ",object{ppLeftFirstToeBase       scale <-1,1,1>}) #end #end
  #ifdef(ppRightFirstToeMiddle    ) #declare ppRightFirstToeMiddleRef     = ppAddBodyPart("ppRightFirstToeMiddle    ",object{ppRightFirstToeMiddle    }) #else #ifdef(ppLeftFirstToeMiddle    ) #declare ppRightFirstToeMiddleRef     = ppAddBodyPart("ppRightFirstToeMiddle    ",object{ppLeftFirstToeMiddle     scale <-1,1,1>}) #end #end
  #ifdef(ppRightFirstToeTip       ) #declare ppRightFirstToeTipRef        = ppAddBodyPart("ppRightFirstToeTip       ",object{ppRightFirstToeTip       }) #else #ifdef(ppLeftFirstToeTip       ) #declare ppRightFirstToeTipRef        = ppAddBodyPart("ppRightFirstToeTip       ",object{ppLeftFirstToeTip        scale <-1,1,1>}) #end #end
  #ifdef(ppRightMiddleToeBase     ) #declare ppRightMiddleToeBaseRef      = ppAddBodyPart("ppRightMiddleToeBase     ",object{ppRightMiddleToeBase     }) #else #ifdef(ppLeftMiddleToeBase     ) #declare ppRightMiddleToeBaseRef      = ppAddBodyPart("ppRightMiddleToeBase     ",object{ppLeftMiddleToeBase      scale <-1,1,1>}) #end #end
  #ifdef(ppRightMiddleToeMiddle   ) #declare ppRightMiddleToeMiddleRef    = ppAddBodyPart("ppRightMiddleToeMiddle   ",object{ppRightMiddleToeMiddle   }) #else #ifdef(ppLeftMiddleToeMiddle   ) #declare ppRightMiddleToeMiddleRef    = ppAddBodyPart("ppRightMiddleToeMiddle   ",object{ppLeftMiddleToeMiddle    scale <-1,1,1>}) #end #end
  #ifdef(ppRightMiddleToeTip      ) #declare ppRightMiddleToeTipRef       = ppAddBodyPart("ppRightMiddleToeTip      ",object{ppRightMiddleToeTip      }) #else #ifdef(ppLeftMiddleToeTip      ) #declare ppRightMiddleToeTipRef       = ppAddBodyPart("ppRightMiddleToeTip      ",object{ppLeftMiddleToeTip       scale <-1,1,1>}) #end #end
  #ifdef(ppRightThirdToeBase      ) #declare ppRightThirdToeBaseRef       = ppAddBodyPart("ppRightThirdToeBase      ",object{ppRightThirdToeBase      }) #else #ifdef(ppLeftThirdToeBase      ) #declare ppRightThirdToeBaseRef       = ppAddBodyPart("ppRightThirdToeBase      ",object{ppLeftThirdToeBase       scale <-1,1,1>}) #end #end
  #ifdef(ppRightThirdToeMiddle    ) #declare ppRightThirdToeMiddleRef     = ppAddBodyPart("ppRightThirdToeMiddle    ",object{ppRightThirdToeMiddle    }) #else #ifdef(ppLeftThirdToeMiddle    ) #declare ppRightThirdToeMiddleRef     = ppAddBodyPart("ppRightThirdToeMiddle    ",object{ppLeftThirdToeMiddle     scale <-1,1,1>}) #end #end
  #ifdef(ppRightThirdToeTip       ) #declare ppRightThirdToeTipRef        = ppAddBodyPart("ppRightThirdToeTip       ",object{ppRightThirdToeTip       }) #else #ifdef(ppLeftThirdToeTip       ) #declare ppRightThirdToeTipRef        = ppAddBodyPart("ppRightThirdToeTip       ",object{ppLeftThirdToeTip        scale <-1,1,1>}) #end #end
  #ifdef(ppRightLittleToeBase     ) #declare ppRightLittleToeBaseRef      = ppAddBodyPart("ppRightLittleToeBase     ",object{ppRightLittleToeBase     }) #else #ifdef(ppLeftLittleToeBase     ) #declare ppRightLittleToeBaseRef      = ppAddBodyPart("ppRightLittleToeBase     ",object{ppLeftLittleToeBase      scale <-1,1,1>}) #end #end
  #ifdef(ppRightLittleToeMiddle   ) #declare ppRightLittleToeMiddleRef    = ppAddBodyPart("ppRightLittleToeMiddle   ",object{ppRightLittleToeMiddle   }) #else #ifdef(ppLeftLittleToeMiddle   ) #declare ppRightLittleToeMiddleRef    = ppAddBodyPart("ppRightLittleToeMiddle   ",object{ppLeftLittleToeMiddle    scale <-1,1,1>}) #end #end
  #ifdef(ppRightLittleToeTip      ) #declare ppRightLittleToeTipRef       = ppAddBodyPart("ppRightLittleToeTip      ",object{ppRightLittleToeTip      }) #else #ifdef(ppLeftLittleToeTip      ) #declare ppRightLittleToeTipRef       = ppAddBodyPart("ppRightLittleToeTip      ",object{ppLeftLittleToeTip       scale <-1,1,1>}) #end #end
                                                                                                                                                                                                                                                                                                                            
  #ifdef(ppRightBigToeNail        ) #declare ppRightBigToeNailRef         = ppAddBodyPart("ppRightBigToeNail        ",object{ppRightBigToeNail        }) #else #ifdef(ppLeftBigToeNail        ) #declare ppRightBigToeNailRef         = ppAddBodyPart("ppRightBigToeNail        ",object{ppLeftBigToeNail         scale <-1,1,1>}) #end #end
  #ifdef(ppRightFirstToeNail      ) #declare ppRightFirstToeNailRef       = ppAddBodyPart("ppRightFirstToeNail      ",object{ppRightFirstToeNail      }) #else #ifdef(ppLeftFirstToeNail      ) #declare ppRightFirstToeNailRef       = ppAddBodyPart("ppRightFirstToeNail      ",object{ppLeftFirstToeNail       scale <-1,1,1>}) #end #end
  #ifdef(ppRightMiddleToeNail     ) #declare ppRightMiddleToeNailRef      = ppAddBodyPart("ppRightMiddleToeNail     ",object{ppRightMiddleToeNail     }) #else #ifdef(ppLeftMiddleToeNail     ) #declare ppRightMiddleToeNailRef      = ppAddBodyPart("ppRightMiddleToeNail     ",object{ppLeftMiddleToeNail      scale <-1,1,1>}) #end #end
  #ifdef(ppRightThirdToeNail      ) #declare ppRightThirdToeNailRef       = ppAddBodyPart("ppRightThirdToeNail      ",object{ppRightThirdToeNail      }) #else #ifdef(ppLeftThirdToeNail      ) #declare ppRightThirdToeNailRef       = ppAddBodyPart("ppRightThirdToeNail      ",object{ppLeftThirdToeNail       scale <-1,1,1>}) #end #end
  #ifdef(ppRightLittleToeNail     ) #declare ppRightLittleToeNailRef      = ppAddBodyPart("ppRightLittleToeNail     ",object{ppRightLittleToeNail     }) #else #ifdef(ppLeftLittleToeNail     ) #declare ppRightLittleToeNailRef      = ppAddBodyPart("ppRightLittleToeNail     ",object{ppLeftLittleToeNail      scale <-1,1,1>}) #end #end

#end



// This macro is used to add a series of joints to the figure matrix. This macro is specific to a particular class of figure (e.g. human001). 
// Each joint defines a junction between 2 objects. Each object can be used in multiple joint definitions. The joint centre for an object is the 
// centre point of the joint relative to the origin for that object (which is why <0,0,0> crops up quite often).
// The objects that are referenced need to have already been added to the figure matrixed or an error will occur when this macro is executed. 
//
// Parameters:
// -----------  
// - This macro has no parameters
// 

#macro ppAddJoints()
  #declare ppUpperNeckJointRef    = ppAddJoint("ppUpperNeckJointRef   ",ppNeckRef   ,ppHeadRef   ,<0, 0.1 ,0>    ,<0,-0.12,0>    ,y,x,z,-90,90,-80,45,-30,30)
  #declare ppLowerNeckJointRef    = ppAddJoint("ppLowerNeckJointRef   ",ppChestRef  ,ppNeckRef   ,<0, 0.12,0>    ,<0,0,0>        ,y,x,z,-30,30,  0,20,-30,30)
  #declare ppChestAbdomenJointRef = ppAddJoint("ppChestAbdomenJointRef",ppAbdomenRef,ppChestRef  ,<0, 0.1,-0.04> ,<0,-0.1,0>     ,y,x,z,-20,20,  0,15,-30,30)
  #declare ppAbdomenHipJointRef   = ppAddJoint("ppAbdomenHipJointRef  ",ppHipRef    ,ppAbdomenRef,<0, 0.12 ,-0.055>,<0,-0.05,-0.01>,y,x,z,-20,20,  0,15,-30,30)
  
  #declare ppLeftShoulderBladeJointRef      = ppAddJoint("ppLeftShoulderBladeJointRef",ppChestRef                  ,ppLeftShoulderRef           ,<0 , 0.12 ,0 >,< 0   ,0   ,0   >,y,-x,-z,-90,90,-95  ,180,-45,105)
                                              
  #declare ppLeftShoulderJointRef           = ppAddJoint("ppLeftShoulderJointRef          ",ppChestRef                  ,ppLeftUpperArmRef           ,<-0.15 , 0.12 ,-0.02 >,< 0.04,0   ,0   >,y,-x,-z,-90,90,-95  ,180,-45,105)
  #declare ppLeftElbowJointRef              = ppAddJoint("ppLeftElbowJointRef             ",ppLeftUpperArmRef           ,ppLeftForeArmRef            ,< 0    ,-0.305, 0    >,< 0   ,0   ,0   >,y,-x,-z,-20,20,0  ,165,0,0)
  #declare ppLeftWristJointRef              = ppAddJoint("ppLeftWristJointRef             ",ppLeftForeArmRef            ,ppLeftPalmRef               ,<-0.01 ,-0.235, 0    >,ppLeftPalmWristPos  ,y,z,-x,-90,45,-90,85,-30,30)     //<0,0,0>
  #declare ppLeftThumbBaseJointRef          = ppAddJoint("ppLeftThumbBaseJointRef         ",ppLeftPalmRef               ,ppLeftThumbBaseRef          ,ppLeftPalmThumbPos     ,<-0.01,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)     //< 0.012,-0.018, 0.042>
  #declare ppLeftThumbMiddleJointRef        = ppAddJoint("ppLeftThumbMiddleJointRef       ",ppLeftThumbBaseRef          ,ppLeftThumbMiddleRef        ,ppLeftThumbJointPos[0] ,< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftThumbTipJointRef           = ppAddJoint("ppLeftThumbTipJointRef          ",ppLeftThumbMiddleRef        ,ppLeftThumbTipRef           ,ppLeftThumbJointPos[1] ,< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftFirstFingerBaseJointRef    = ppAddJoint("ppLeftFirstFingerBaseJointRef   ",ppLeftPalmRef               ,ppLeftFirstFingerBaseRef    ,ppLeftPalmFinger1Pos   ,< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)     // < 0.027,-0.10 , 0.032>
  #declare ppLeftFirstFingerMiddleJointRef  = ppAddJoint("ppLeftFirstFingerMiddleJointRef ",ppLeftFirstFingerBaseRef    ,ppLeftFirstFingerMiddleRef  ,ppLeftFingerJointPos[0],< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftFirstFingerTipJointRef     = ppAddJoint("ppLeftFirstFingerTipJointRef    ",ppLeftFirstFingerMiddleRef  ,ppLeftFirstFingerTipRef     ,ppLeftFingerJointPos[1],< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftMiddleFingerBaseJointRef   = ppAddJoint("ppLeftMiddleFingerBaseJointRef  ",ppLeftPalmRef               ,ppLeftMiddleFingerBaseRef   ,ppLeftPalmFinger2Pos   ,< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)     //  < 0.02 ,-0.105, 0.01 >
  #declare ppLeftMiddleFingerMiddleJointRef = ppAddJoint("ppLeftMiddleFingerMiddleJointRef",ppLeftMiddleFingerBaseRef   ,ppLeftMiddleFingerMiddleRef ,ppLeftFingerJointPos[0],< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftMiddleFingerTipJointRef    = ppAddJoint("ppLeftMiddleFingerTipJointRef   ",ppLeftMiddleFingerMiddleRef ,ppLeftMiddleFingerTipRef    ,ppLeftFingerJointPos[1],< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftThirdFingerBaseJointRef    = ppAddJoint("ppLeftThirdFingerBaseJointRef   ",ppLeftPalmRef               ,ppLeftThirdFingerBaseRef    ,ppLeftPalmFinger3Pos   ,< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)     // < 0.02 ,-0.10 ,-0.01 >
  #declare ppLeftThirdFingerMiddleJointRef  = ppAddJoint("ppLeftThirdFingerMiddleJointRef ",ppLeftThirdFingerBaseRef    ,ppLeftThirdFingerMiddleRef  ,ppLeftFingerJointPos[0],< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftThirdFingerTipJointRef     = ppAddJoint("ppLeftThirdFingerTipJointRef    ",ppLeftThirdFingerMiddleRef  ,ppLeftThirdFingerTipRef     ,ppLeftFingerJointPos[1],< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftLittleFingerBaseJointRef   = ppAddJoint("ppLeftLittleFingerBaseJointRef  ",ppLeftPalmRef               ,ppLeftLittleFingerBaseRef   ,ppLeftPalmFinger4Pos   ,< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)     // < 0.02 ,-0.095,-0.034>
  #declare ppLeftLittleFingerMiddleJointRef = ppAddJoint("ppLeftLittleFingerMiddleJointRef",ppLeftLittleFingerBaseRef   ,ppLeftLittleFingerMiddleRef ,ppLeftFingerJointPos[0],< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #declare ppLeftLittleFingerTipJointRef    = ppAddJoint("ppLeftLittleFingerTipJointRef   ",ppLeftLittleFingerMiddleRef ,ppLeftLittleFingerTipRef    ,ppLeftFingerJointPos[1],< 0   ,0   ,0   >,y,z,-x,-90,90,-90,90,-90,90)
  #ifdef(ppLeftThumbNailRef)        #declare ppLeftThumbNailJointRef        = ppAddJoint("ppLeftThumbNailJointRef       ",ppLeftThumbTipRef       ,ppLeftThumbNailRef        ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftFirstFingerNailRef)  #declare ppLeftFirstFingerNailJointRef  = ppAddJoint("ppLeftFirstFingerNailJointRef ",ppLeftFirstFingerTipRef ,ppLeftFirstFingerNailRef  ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftMiddleFingerNailRef) #declare ppLeftMiddleFingerNailJointRef = ppAddJoint("ppLeftMiddleFingerNailJointRef",ppLeftMiddleFingerTipRef,ppLeftMiddleFingerNailRef ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftThirdFingerNailRef)  #declare ppLeftThirdFingerNailJointRef  = ppAddJoint("ppLeftThirdFingerNailJointRef ",ppLeftThirdFingerTipRef ,ppLeftThirdFingerNailRef  ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftLittleFingerNailRef) #declare ppLeftLittleFingerNailJointRef = ppAddJoint("ppLeftLittleFingerNailJointRef",ppLeftLittleFingerTipRef,ppLeftLittleFingerNailRef ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                                                                                                  
   
  #declare ppLeftHipJointRef    = ppAddJoint("ppLeftHipJointRef  ",ppHipRef        ,ppLeftThighRef       ,<-0.09,-0.028,-0.054>,<0,0.43,-0.020>,y,-x,z,-90,90,-90,90,-90,90)
  #declare ppLeftKneeJointRef   = ppAddJoint("ppLeftKneeJointRef ",ppLeftThighRef  ,ppLeftCalfRef        ,<0,-0.02,0.02>      ,<0,0.42,0>,y,x,z,-90,90,-90,90,-90,90)                               
  #declare ppLeftAnkleJointRef  = ppAddJoint("ppLeftAnkleJointRef",ppLeftCalfRef   ,ppLeftFootRef        ,<0,-0.01,-0.015>    ,ppLeftFootAnklePos ,y,x,z,-90,90,-90,90,-90,90)                                
                                                                                                                                                                             
  #declare ppLeftBigToeBaseJointRef        = ppAddJoint("ppLeftBigToeBaseJointRef     ",ppLeftFootRef            ,ppLeftBigToeBaseRef      ,ppLeftFootBigToePos,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)         
  #declare ppLeftBigToeTipJointRef         = ppAddJoint("ppLeftBigToeTipJointRef      ",ppLeftBigToeBaseRef      ,ppLeftBigToeTipRef       ,ppToeJointPos[0]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)             
  #declare ppLeftFirstToeBaseJointRef      = ppAddJoint("ppLeftFirstToeBaseJointRef   ",ppLeftFootRef            ,ppLeftFirstToeBaseRef    ,ppLeftFootToe1Pos  ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)         
  #declare ppLeftFirstToeMiddleJointRef    = ppAddJoint("ppLeftFirstToeMiddleJointRef ",ppLeftFirstToeBaseRef    ,ppLeftFirstToeMiddleRef  ,ppToeJointPos[0]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftFirstToeTipJointRef       = ppAddJoint("ppLeftFirstToeTipJointRef    ",ppLeftFirstToeMiddleRef  ,ppLeftFirstToeTipRef     ,ppToeJointPos[1]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftMiddleToeBaseJointRef     = ppAddJoint("ppLeftMiddleToeBaseJointRef  ",ppLeftFootRef            ,ppLeftMiddleToeBaseRef   ,ppLeftFootToe2Pos  ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftMiddleToeMiddleJointRef   = ppAddJoint("ppLeftMiddleToeMiddleJointRef",ppLeftMiddleToeBaseRef   ,ppLeftMiddleToeMiddleRef ,ppToeJointPos[0]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftMiddleToeTipJointRef      = ppAddJoint("ppLeftMiddleToeTipJointRef   ",ppLeftMiddleToeMiddleRef ,ppLeftMiddleToeTipRef    ,ppToeJointPos[1]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftThirdToeBaseJointRef      = ppAddJoint("ppLeftThirdToeBaseJointRef   ",ppLeftFootRef            ,ppLeftThirdToeBaseRef    ,ppLeftFootToe3Pos  ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftThirdToeMiddleJointRef    = ppAddJoint("ppLeftThirdToeMiddleJointRef ",ppLeftThirdToeBaseRef    ,ppLeftThirdToeMiddleRef  ,ppToeJointPos[0]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftThirdToeTipJointRef       = ppAddJoint("ppLeftThirdToeTipJointRef    ",ppLeftThirdToeMiddleRef  ,ppLeftThirdToeTipRef     ,ppToeJointPos[1]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftLittleToeBaseJointRef     = ppAddJoint("ppLeftLittleToeBaseJointRef  ",ppLeftFootRef            ,ppLeftLittleToeBaseRef   ,ppLeftFootToe4Pos  ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftLittleToeMiddleJointRef   = ppAddJoint("ppLeftLittleToeMiddleJointRef",ppLeftLittleToeBaseRef   ,ppLeftLittleToeMiddleRef ,ppToeJointPos[0]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  #declare ppLeftLittleToeTipJointRef      = ppAddJoint("ppLeftLittleToeTipJointRef   ",ppLeftLittleToeMiddleRef ,ppLeftLittleToeTipRef    ,ppToeJointPos[1]   ,<0,0,0>,z,x,y,-90,90,-90,90,-90,90)
  
  #ifdef(ppLeftBigToeNailRef)    #declare ppLeftBigToeNailJointRef    = ppAddJoint("ppLeftBigToeNailJointRef   ",ppLeftBigToeTipRef   ,ppLeftBigToeNailRef   ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftFirstToeNailRef)  #declare ppLeftFirstToeNailJointRef  = ppAddJoint("ppLeftFirstToeNailJointRef ",ppLeftFirstToeTipRef ,ppLeftFirstToeNailRef ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftMiddleToeNailRef) #declare ppLeftMiddleToeNailJointRef = ppAddJoint("ppLeftMiddleToeNailJointRef",ppLeftMiddleToeTipRef,ppLeftMiddleToeNailRef,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftThirdToeNailRef)  #declare ppLeftThirdToeNailJointRef  = ppAddJoint("ppLeftThirdToeNailJointRef ",ppLeftThirdToeTipRef ,ppLeftThirdToeNailRef ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftLittleToeNailRef) #declare ppLeftLittleToeNailJointRef = ppAddJoint("ppLeftLittleToeNailJointRef",ppLeftLittleToeTipRef,ppLeftLittleToeNailRef,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  
  #ifdef(ppLeftLipsRef)        #declare ppLeftLipsJointRef        = ppAddJoint("ppLeftLipsJointRef       ",ppHeadRef,ppLeftLipsRef       ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftUpperEyeLidRef) #declare ppLeftUpperEyeLidJointRef = ppAddJoint("ppLeftUpperEyeLidJointRef",ppHeadRef,ppLeftUpperEyeLidRef,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftLowerEyeLidRef) #declare ppLeftLowerEyeLidJointRef = ppAddJoint("ppLeftLowerEyeLidJointRef",ppHeadRef,ppLeftLowerEyeLidRef,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftEyeRef)         #declare ppLeftEyeJointRef         = ppAddJoint("ppLeftEyeJointRef        ",ppHeadRef,ppLeftEyeRef        ,ppAdjustedEyePosition,<0,0,0>,z,y,x,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftEarRef)         #declare ppLeftEarJointRef         = ppAddJoint("ppLeftEarJointRef        ",ppHeadRef,ppLeftEarRef        ,<0,0,0>,<0,0,0>,x,y,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftUpperLashRef)   #declare ppLeftUpperLashJointRef   = ppAddJoint("ppLeftUpperLashJointRef  ",ppHeadRef,ppLeftUpperLashRef  ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftLowerLashRef)   #declare ppLeftLowerLashJointRef   = ppAddJoint("ppLeftLowerLashJointRef  ",ppHeadRef,ppLeftLowerLashRef  ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLeftEyeBrowRef)     #declare ppLeftEyeBrowJointRef     = ppAddJoint("ppLeftEyeBrowJointRef    ",ppHeadRef,ppLeftEyeBrowRef    ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppUpperTeethRef)      #declare ppUpperTeethJointRef      = ppAddJoint("ppUpperTeethJointRef     ",ppHeadRef,ppUpperTeethRef     ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppLowerTeethRef)      #declare ppLowerTeethJointRef      = ppAddJoint("ppLowerTeethJointRef     ",ppHeadRef,ppLowerTeethRef     ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppHairRef)            #declare ppHairJointRef            = ppAddJoint("ppHairJointRef           ",ppHeadRef,ppHairRef           ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                            
  #ifdef(ppBeardRef)           #declare ppBeardJointRef           = ppAddJoint("ppBeardJointRef          ",ppHeadRef,ppBeardRef          ,<0,0,0>,<0,0,0>,y,x,z,0,0,0,0,0,0) #end                                                                                                                                                    
  
  
  #declare ppRightShoulderBladeJointRef      = ppMirrorJointDefinition(ppLeftShoulderBladeJointRef,"ppRightShoulderBladeJointRef     ",ppChestRef                  ,ppRightShoulderRef)
  
  #declare ppRightShoulderJointRef           = ppMirrorJointDefinition(ppLeftShoulderJointRef          ,"ppRightShoulderJointRef          ",ppChestRef                  ,ppRightUpperArmRef)
  #declare ppRightElbowJointRef              = ppMirrorJointDefinition(ppLeftElbowJointRef             ,"ppRightElbowJointRef             ",ppRightUpperArmRef          ,ppRightForeArmRef           )    
  #declare ppRightWristJointRef              = ppMirrorJointDefinition(ppLeftWristJointRef             ,"ppRightWristJointRef             ",ppRightForeArmRef           ,ppRightPalmRef              )      
  #declare ppRightThumbBaseJointRef          = ppMirrorJointDefinition(ppLeftThumbBaseJointRef         ,"ppRightThumbBaseJointRef         ",ppRightPalmRef              ,ppRightThumbBaseRef         )
  #declare ppRightThumbMiddleJointRef        = ppMirrorJointDefinition(ppLeftThumbMiddleJointRef       ,"ppRightThumbMiddleJointRef       ",ppRightThumbBaseRef         ,ppRightThumbMiddleRef       )
  #declare ppRightThumbTipJointRef           = ppMirrorJointDefinition(ppLeftThumbTipJointRef          ,"ppRightThumbTipJointRef          ",ppRightThumbMiddleRef       ,ppRightThumbTipRef          )
  #declare ppRightFirstFingerBaseJointRef    = ppMirrorJointDefinition(ppLeftFirstFingerBaseJointRef   ,"ppRightFirstFingerBaseJointRef   ",ppRightPalmRef              ,ppRightFirstFingerBaseRef   )
  #declare ppRightFirstFingerMiddleJointRef  = ppMirrorJointDefinition(ppLeftFirstFingerMiddleJointRef ,"ppRightFirstFingerMiddleJointRef ",ppRightFirstFingerBaseRef   ,ppRightFirstFingerMiddleRef )
  #declare ppRightFirstFingerTipJointRef     = ppMirrorJointDefinition(ppLeftFirstFingerTipJointRef    ,"ppRightFirstFingerTipJointRef    ",ppRightFirstFingerMiddleRef ,ppRightFirstFingerTipRef    )
  #declare ppRightMiddleFingerBaseJointRef   = ppMirrorJointDefinition(ppLeftMiddleFingerBaseJointRef  ,"ppRightMiddleFingerBaseJointRef  ",ppRightPalmRef              ,ppRightMiddleFingerBaseRef  )
  #declare ppRightMiddleFingerMiddleJointRef = ppMirrorJointDefinition(ppLeftMiddleFingerMiddleJointRef,"ppRightMiddleFingerMiddleJointRef",ppRightMiddleFingerBaseRef  ,ppRightMiddleFingerMiddleRef)
  #declare ppRightMiddleFingerTipJointRef    = ppMirrorJointDefinition(ppLeftMiddleFingerTipJointRef   ,"ppRightMiddleFingerTipJointRef   ",ppRightMiddleFingerMiddleRef,ppRightMiddleFingerTipRef   )
  #declare ppRightThirdFingerBaseJointRef    = ppMirrorJointDefinition(ppLeftThirdFingerBaseJointRef   ,"ppRightThirdFingerBaseJointRef   ",ppRightPalmRef              ,ppRightThirdFingerBaseRef   )
  #declare ppRightThirdFingerMiddleJointRef  = ppMirrorJointDefinition(ppLeftThirdFingerMiddleJointRef ,"ppRightThirdFingerMiddleJointRef ",ppRightThirdFingerBaseRef   ,ppRightThirdFingerMiddleRef )
  #declare ppRightThirdFingerTipJointRef     = ppMirrorJointDefinition(ppLeftThirdFingerTipJointRef    ,"ppRightThirdFingerTipJointRef    ",ppRightThirdFingerMiddleRef ,ppRightThirdFingerTipRef    )
  #declare ppRightLittleFingerBaseJointRef   = ppMirrorJointDefinition(ppLeftLittleFingerBaseJointRef  ,"ppRightLittleFingerBaseJointRef  ",ppRightPalmRef              ,ppRightLittleFingerBaseRef  )
  #declare ppRightLittleFingerMiddleJointRef = ppMirrorJointDefinition(ppLeftLittleFingerMiddleJointRef,"ppRightLittleFingerMiddleJointRef",ppRightLittleFingerBaseRef  ,ppRightLittleFingerMiddleRef)
  #declare ppRightLittleFingerTipJointRef    = ppMirrorJointDefinition(ppLeftLittleFingerTipJointRef   ,"ppRightLittleFingerTipJointRef   ",ppRightLittleFingerMiddleRef,ppRightLittleFingerTipRef   )
  #ifdef(ppRightThumbNailRef)        #declare ppRightThumbNailJointRef        = ppMirrorJointDefinition(ppLeftThumbNailJointRef       ,"ppRightThumbNailJointRef       ",ppRightThumbTipRef       ,ppRightThumbNailRef       ) #end                                                                                                                                                    
  #ifdef(ppRightFirstFingerNailRef)  #declare ppRightFirstFingerNailJointRef  = ppMirrorJointDefinition(ppLeftFirstFingerNailJointRef ,"ppRightFirstFingerNailJointRef ",ppRightFirstFingerTipRef ,ppRightFirstFingerNailRef ) #end                                                                                                                                                    
  #ifdef(ppRightMiddleFingerNailRef) #declare ppRightMiddleFingerNailJointRef = ppMirrorJointDefinition(ppLeftMiddleFingerNailJointRef,"ppRightMiddleFingerNailJointRef",ppRightMiddleFingerTipRef,ppRightMiddleFingerNailRef) #end                                                                                                                                                    
  #ifdef(ppRightThirdFingerNailRef)  #declare ppRightThirdFingerNailJointRef  = ppMirrorJointDefinition(ppLeftThirdFingerNailJointRef ,"ppRightThirdFingerNailJointRef ",ppRightThirdFingerTipRef ,ppRightThirdFingerNailRef ) #end                                                                                                                                                    
  #ifdef(ppRightLittleFingerNailRef) #declare ppRightLittleFingerNailJointRef = ppMirrorJointDefinition(ppLeftLittleFingerNailJointRef,"ppRightLittleFingerNailJointRef",ppRightLittleFingerTipRef,ppRightLittleFingerNailRef) #end                                                                                                                                                    
  
  #declare ppRightHipJointRef    = ppMirrorJointDefinition(ppLeftHipJointRef  ,"ppRightHipJointRef  ",ppHipRef        ,ppRightThighRef)   
  #declare ppRightKneeJointRef   = ppMirrorJointDefinition(ppLeftKneeJointRef ,"ppRightKneeJointRef ",ppRightThighRef ,ppRightCalfRef )       
  #declare ppRightAnkleJointRef  = ppMirrorJointDefinition(ppLeftAnkleJointRef,"ppRightAnkleJointRef",ppRightCalfRef  ,ppRightFootRef )        
   
  #declare ppRightBigToeBaseJointRef        = ppMirrorJointDefinition(ppLeftBigToeBaseJointRef     ,"ppRightBigToeBaseJointRef     ",ppRightFootRef           ,ppRightBigToeBaseRef     )
  #declare ppRightBigToeTipJointRef         = ppMirrorJointDefinition(ppLeftBigToeTipJointRef      ,"ppRightBigToeTipJointRef      ",ppRightBigToeBaseRef     ,ppRightBigToeTipRef      )
  #declare ppRightFirstToeBaseJointRef      = ppMirrorJointDefinition(ppLeftFirstToeBaseJointRef   ,"ppRightFirstToeBaseJointRef   ",ppRightFootRef           ,ppRightFirstToeBaseRef   )
  #declare ppRightFirstToeMiddleJointRef    = ppMirrorJointDefinition(ppLeftFirstToeMiddleJointRef ,"ppRightFirstToeMiddleJointRef ",ppRightFirstToeBaseRef   ,ppRightFirstToeMiddleRef )
  #declare ppRightFirstToeTipJointRef       = ppMirrorJointDefinition(ppLeftFirstToeTipJointRef    ,"ppRightFirstToeTipJointRef    ",ppRightFirstToeMiddleRef ,ppRightFirstToeTipRef    )
  #declare ppRightMiddleToeBaseJointRef     = ppMirrorJointDefinition(ppLeftMiddleToeBaseJointRef  ,"ppRightMiddleToeBaseJointRef  ",ppRightFootRef           ,ppRightMiddleToeBaseRef  )
  #declare ppRightMiddleToeMiddleJointRef   = ppMirrorJointDefinition(ppLeftMiddleToeMiddleJointRef,"ppRightMiddleToeMiddleJointRef",ppRightMiddleToeBaseRef  ,ppRightMiddleToeMiddleRef)
  #declare ppRightMiddleToeTipJointRef      = ppMirrorJointDefinition(ppLeftMiddleToeTipJointRef   ,"ppRightMiddleToeTipJointRef   ",ppRightMiddleToeMiddleRef,ppRightMiddleToeTipRef   )
  #declare ppRightThirdToeBaseJointRef      = ppMirrorJointDefinition(ppLeftThirdToeBaseJointRef   ,"ppRightThirdToeBaseJointRef   ",ppRightFootRef           ,ppRightThirdToeBaseRef   )
  #declare ppRightThirdToeMiddleJointRef    = ppMirrorJointDefinition(ppLeftThirdToeMiddleJointRef ,"ppRightThirdToeMiddleJointRef ",ppRightThirdToeBaseRef   ,ppRightThirdToeMiddleRef )
  #declare ppRightThirdToeTipJointRef       = ppMirrorJointDefinition(ppLeftThirdToeTipJointRef    ,"ppRightThirdToeTipJointRef    ",ppRightThirdToeMiddleRef ,ppRightThirdToeTipRef    )
  #declare ppRightLittleToeBaseJointRef     = ppMirrorJointDefinition(ppLeftLittleToeBaseJointRef  ,"ppRightLittleToeBaseJointRef  ",ppRightFootRef           ,ppRightLittleToeBaseRef  )
  #declare ppRightLittleToeMiddleJointRef   = ppMirrorJointDefinition(ppLeftLittleToeMiddleJointRef,"ppRightLittleToeMiddleJointRef",ppRightLittleToeBaseRef  ,ppRightLittleToeMiddleRef)
  #declare ppRightLittleToeTipJointRef      = ppMirrorJointDefinition(ppLeftLittleToeTipJointRef   ,"ppRightLittleToeTipJointRef   ",ppRightLittleToeMiddleRef,ppRightLittleToeTipRef   )
  #ifdef(ppRightBigToeNailRef)    #declare ppRightBigToeNailJointRef    = ppMirrorJointDefinition(ppLeftBigToeNailJointRef   ,"ppRightBigToeNailJointRef   ",ppRightBigToeTipRef   ,ppRightBigToeNailRef   ) #end                                                                                                                                                    
  #ifdef(ppRightFirstToeNailRef)  #declare ppRightFirstToeNailJointRef  = ppMirrorJointDefinition(ppLeftFirstToeNailJointRef ,"ppRightFirstToeNailJointRef ",ppRightFirstToeTipRef ,ppRightFirstToeNailRef ) #end                                                                                                                                                    
  #ifdef(ppRightMiddleToeNailRef) #declare ppRightMiddleToeNailJointRef = ppMirrorJointDefinition(ppLeftMiddleToeNailJointRef,"ppRightMiddleToeNailJointRef",ppRightMiddleToeTipRef,ppRightMiddleToeNailRef) #end                                                                                                                                                    
  #ifdef(ppRightThirdToeNailRef)  #declare ppRightThirdToeNailJointRef  = ppMirrorJointDefinition(ppLeftThirdToeNailJointRef ,"ppRightThirdToeNailJointRef ",ppRightThirdToeTipRef ,ppRightThirdToeNailRef ) #end                                                                                                                                                    
  #ifdef(ppRightLittleToeNailRef) #declare ppRightLittleToeNailJointRef = ppMirrorJointDefinition(ppLeftLittleToeNailJointRef,"ppRightLittleToeNailJointRef",ppRightLittleToeTipRef,ppRightLittleToeNailRef) #end                                                                                                                                                    
  
  #ifdef(ppRightLipsRef)        #declare ppRightLipsJointRef        = ppMirrorJointDefinition(ppLeftLipsJointRef       ,"ppRightLipsJointRef       ",ppHeadRef,ppRightLipsRef       ) #end                                                                                                                                                  
  #ifdef(ppRightUpperEyeLidRef) #declare ppRightUpperEyeLidJointRef = ppMirrorJointDefinition(ppLeftUpperEyeLidJointRef,"ppRightUpperEyeLidJointRef",ppHeadRef,ppRightUpperEyeLidRef) #end                                                                                                                                                    
  #ifdef(ppRightLowerEyeLidRef) #declare ppRightLowerEyeLidJointRef = ppMirrorJointDefinition(ppLeftLowerEyeLidJointRef,"ppRightLowerEyeLidJointRef",ppHeadRef,ppRightLowerEyeLidRef) #end                                                                                                                                                    
//  #ifdef(ppRightEyeRef)         #declare ppRightEyeJointRef         = ppMirrorJointDefinition(ppLeftEyeJointRef        ,"ppRightEyeJointRef        ",ppHeadRef,ppRightEyeRef        ) #end                                                                                                                                                    
  #ifdef(ppRightEyeRef)         #declare ppRightEyeJointRef         = ppAddJoint("ppRightEyeJointRef        ",ppHeadRef,ppRightEyeRef        ,ppAdjustedEyePosition*<-1,1,1>,<0,0,0>,z,y,x,0,0,0,0,0,0) #end                                                                                                                                                    
  #ifdef(ppRightEarRef)         #declare ppRightEarJointRef         = ppMirrorJointDefinition(ppLeftEarJointRef        ,"ppRightEarJointRef        ",ppHeadRef,ppRightEarRef        ) #end                                                                                                                                                    
  #ifdef(ppRightUpperLashRef)   #declare ppRightUpperLashJointRef   = ppMirrorJointDefinition(ppLeftUpperLashJointRef  ,"ppRightUpperLashJointRef  ",ppHeadRef,ppRightUpperLashRef  ) #end                                                                                                                                                    
  #ifdef(ppRightLowerLashRef)   #declare ppRightLowerLashJointRef   = ppMirrorJointDefinition(ppLeftLowerLashJointRef  ,"ppRightLowerLashJointRef  ",ppHeadRef,ppRightLowerLashRef  ) #end                                                                                                                                                    
  #ifdef(ppRightEyeBrowRef)     #declare ppRightEyeBrowJointRef     = ppMirrorJointDefinition(ppLeftEyeBrowJointRef    ,"ppRightEyeBrowJointRef    ",ppHeadRef,ppRightEyeBrowRef    ) #end                                                                                                                                                    
#end


// This macro takes a set of joint positions as defined for a figure and left-right mirrors them across to the opposite side of that figure. 
// Joints on the centre line of the figure have their joint rotation settings mirrored left-right (the y and z rotations are multiplied by -1).
// Joints not on the centre line are left-right mirrored by having their rotation settings swapped over.
// NOTE. There should be a way of selecting which body parts to mirror, as they don't all need mirroring. *** THIS BIT STILL NEEDS WRITING ***.
//
// Parameters:
// -----------
//     ppMirrorIncludeFile    - The name of the file that contains the joint settings for the left joints.

#macro ppMirror(ppMirrorIncludeFile)

  #include ppMirrorIncludeFile

  ppMirrorJoints(ppUpperNeckJointRef   ,-1)
  ppMirrorJoints(ppLowerNeckJointRef   ,-1)
  ppMirrorJoints(ppChestAbdomenJointRef,-1)
  ppMirrorJoints(ppAbdomenHipJointRef  ,-1)
  
  ppMirrorJoints(ppLeftShoulderBladeJointRef     ,ppRightShoulderBladeJointRef     ) 
                                                    
  ppMirrorJoints(ppLeftShoulderJointRef          ,ppRightShoulderJointRef          ) 
  ppMirrorJoints(ppLeftElbowJointRef             ,ppRightElbowJointRef             )
  // The hands shouldn't generally need to be mirrored 
//  ppMirrorJoints(ppLeftWristJointRef             ,ppRightWristJointRef             ) 
//  ppMirrorJoints(ppLeftThumbBaseJointRef         ,ppRightThumbBaseJointRef         ) 
//  ppMirrorJoints(ppLeftThumbMiddleJointRef       ,ppRightThumbMiddleJointRef       ) 
//  ppMirrorJoints(ppLeftThumbTipJointRef          ,ppRightThumbTipJointRef          ) 
//  ppMirrorJoints(ppLeftFirstFingerBaseJointRef   ,ppRightFirstFingerBaseJointRef   ) 
//  ppMirrorJoints(ppLeftFirstFingerMiddleJointRef ,ppRightFirstFingerMiddleJointRef ) 
//  ppMirrorJoints(ppLeftFirstFingerTipJointRef    ,ppRightFirstFingerTipJointRef    ) 
//  ppMirrorJoints(ppLeftMiddleFingerBaseJointRef  ,ppRightMiddleFingerBaseJointRef  ) 
//  ppMirrorJoints(ppLeftMiddleFingerMiddleJointRef,ppRightMiddleFingerMiddleJointRef) 
//  ppMirrorJoints(ppLeftMiddleFingerTipJointRef   ,ppRightMiddleFingerTipJointRef   ) 
//  ppMirrorJoints(ppLeftThirdFingerBaseJointRef   ,ppRightThirdFingerBaseJointRef   ) 
//  ppMirrorJoints(ppLeftThirdFingerMiddleJointRef ,ppRightThirdFingerMiddleJointRef ) 
//  ppMirrorJoints(ppLeftThirdFingerTipJointRef    ,ppRightThirdFingerTipJointRef    ) 
//  ppMirrorJoints(ppLeftLittleFingerBaseJointRef  ,ppRightLittleFingerBaseJointRef  ) 
//  ppMirrorJoints(ppLeftLittleFingerMiddleJointRef,ppRightLittleFingerMiddleJointRef) 
//  ppMirrorJoints(ppLeftLittleFingerTipJointRef   ,ppRightLittleFingerTipJointRef   ) 
//  
//  
//  #ifdef(ppLeftThumbNailJointRef       ) #ifdef(ppRightThumbNailJointRef       ) ppMirrorJoints(ppLeftThumbNailJointRef       ,ppRightThumbNailJointRef       )  #end #end                                                                                                                                                   
//  #ifdef(ppLeftFirstFingerNailJointRef ) #ifdef(ppRightFirstFingerNailJointRef ) ppMirrorJoints(ppLeftFirstFingerNailJointRef ,ppRightFirstFingerNailJointRef )  #end #end                                                                                                                                                   
//  #ifdef(ppLeftMiddleFingerNailJointRef) #ifdef(ppRightMiddleFingerNailJointRef) ppMirrorJoints(ppLeftMiddleFingerNailJointRef,ppRightMiddleFingerNailJointRef)  #end #end                                                                                                                                                   
//  #ifdef(ppLeftThirdFingerNailJointRef ) #ifdef(ppRightThirdFingerNailJointRef ) ppMirrorJoints(ppLeftThirdFingerNailJointRef ,ppRightThirdFingerNailJointRef )  #end #end                                                                                                                                                   
//  #ifdef(ppLeftLittleFingerNailJointRef) #ifdef(ppRightLittleFingerNailJointRef) ppMirrorJoints(ppLeftLittleFingerNailJointRef,ppRightLittleFingerNailJointRef)  #end #end                                                                                                                                                   
                                                                                
  ppMirrorJoints(ppLeftHipJointRef            ,ppRightHipJointRef            )
  ppMirrorJoints(ppLeftKneeJointRef           ,ppRightKneeJointRef           )                  
  ppMirrorJoints(ppLeftAnkleJointRef          ,ppRightAnkleJointRef          )                            

  ppMirrorJoints(ppLeftBigToeBaseJointRef     ,ppRightBigToeBaseJointRef     )     
  ppMirrorJoints(ppLeftBigToeTipJointRef      ,ppRightBigToeTipJointRef      )         
  ppMirrorJoints(ppLeftFirstToeBaseJointRef   ,ppRightFirstToeBaseJointRef   )     
  ppMirrorJoints(ppLeftFirstToeMiddleJointRef ,ppRightFirstToeMiddleJointRef )
  ppMirrorJoints(ppLeftFirstToeTipJointRef    ,ppRightFirstToeTipJointRef    )
  ppMirrorJoints(ppLeftMiddleToeBaseJointRef  ,ppRightMiddleToeBaseJointRef  )
  ppMirrorJoints(ppLeftMiddleToeMiddleJointRef,ppRightMiddleToeMiddleJointRef)
  ppMirrorJoints(ppLeftMiddleToeTipJointRef   ,ppRightMiddleToeTipJointRef   )
  ppMirrorJoints(ppLeftThirdToeBaseJointRef   ,ppRightThirdToeBaseJointRef   )
  ppMirrorJoints(ppLeftThirdToeMiddleJointRef ,ppRightThirdToeMiddleJointRef )
  ppMirrorJoints(ppLeftThirdToeTipJointRef    ,ppRightThirdToeTipJointRef    )
  ppMirrorJoints(ppLeftLittleToeBaseJointRef  ,ppRightLittleToeBaseJointRef  )
  ppMirrorJoints(ppLeftLittleToeMiddleJointRef,ppRightLittleToeMiddleJointRef)
  ppMirrorJoints(ppLeftLittleToeTipJointRef   ,ppRightLittleToeTipJointRef   )
  
  #ifdef(ppLeftBigToeNailJointRef   ) #ifdef(ppRightBigToeNailJointRef   ) ppMirrorJoints(ppLeftBigToeNailJointRef   ,ppRightBigToeNailJointRef   )  #end #end                                                                                                                                                   
  #ifdef(ppLeftFirstToeNailJointRef ) #ifdef(ppRightFirstToeNailJointRef ) ppMirrorJoints(ppLeftFirstToeNailJointRef ,ppRightFirstToeNailJointRef )  #end #end                                                                                                                                                   
  #ifdef(ppLeftMiddleToeNailJointRef) #ifdef(ppRightMiddleToeNailJointRef) ppMirrorJoints(ppLeftMiddleToeNailJointRef,ppRightMiddleToeNailJointRef)  #end #end                                                                                                                                                   
  #ifdef(ppLeftThirdToeNailJointRef ) #ifdef(ppRightThirdToeNailJointRef ) ppMirrorJoints(ppLeftThirdToeNailJointRef ,ppRightThirdToeNailJointRef )  #end #end                                                                                                                                                   
  #ifdef(ppLeftLittleToeNailJointRef) #ifdef(ppRightLittleToeNailJointRef) ppMirrorJoints(ppLeftLittleToeNailJointRef,ppRightLittleToeNailJointRef)  #end #end                                                                                                                                                   

#end


// This macro is used to set a series of trivial objects to any required body part variables that have not yet been set.
// This is intended to enable a render to complete even if a model definition is incomplete. 
//
// Parameters:
// -----------  
// - This macro has no parameters
// 
#macro ppnullbodyparts()
  #ifndef(ppLeftEar)    #declare ppLeftEar    = sphere{<0,0,0>,0.0000001} #end
  #ifndef(ppRightEar)   #declare ppRightEar   = sphere{<0,0,0>,0.0000001} #end
  #ifndef(ppHead)       #declare ppHead       = sphere{<0,0,0>,0.0000001} #end
  #ifndef(ppNeck)       #declare ppNeck       = sphere{<0,0,0>,0.0000001} #end
  #ifndef(ppChest)      #declare ppChest      = sphere{<0,0,0>,0.0000001} #end
  #ifndef(ppAbdomen)    #declare ppAbdomen    = sphere{<0,0,0>,0.0000001} #end
  #ifndef(ppHip)        #declare ppHip        = sphere{<0,0,0>,0.0000001} #end
  
  #ifndef (ppLeftUpperArm)             #declare ppLeftUpperArm =            sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftForeArm)              #declare ppLeftForeArm =             sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftPalm)                 #declare ppLeftPalm =                sphere{<0,0,0>,0.0000001} #end                            
  #ifndef (ppLeftThumbBase)            #declare ppLeftThumbBase =           sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftThumbMiddle)          #declare ppLeftThumbMiddle =         sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftThumbTip)             #declare ppLeftThumbTip =            sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftFirstFingerBase)      #declare ppLeftFirstFingerBase =     sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftFirstFingerMiddle)    #declare ppLeftFirstFingerMiddle =   sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftFirstFingerTip)       #declare ppLeftFirstFingerTip =      sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftMiddleFingerBase)     #declare ppLeftMiddleFingerBase =    sphere{<0,0,0>,0.0000001} #end                                 
  #ifndef (ppLeftMiddleFingerMiddle)   #declare ppLeftMiddleFingerMiddle =  sphere{<0,0,0>,0.0000001} #end                                 
  #ifndef (ppLeftMiddleFingerTip)      #declare ppLeftMiddleFingerTip =     sphere{<0,0,0>,0.0000001} #end         
  #ifndef (ppLeftThirdFingerBase)      #declare ppLeftThirdFingerBase =     sphere{<0,0,0>,0.0000001} #end         
  #ifndef (ppLeftThirdFingerMiddle)    #declare ppLeftThirdFingerMiddle =   sphere{<0,0,0>,0.0000001} #end         
  #ifndef (ppLeftThirdFingerTip)       #declare ppLeftThirdFingerTip =      sphere{<0,0,0>,0.0000001} #end         
  #ifndef (ppLeftLittleFingerBase)     #declare ppLeftLittleFingerBase =    sphere{<0,0,0>,0.0000001} #end         
  #ifndef (ppLeftLittleFingerMiddle)   #declare ppLeftLittleFingerMiddle =  sphere{<0,0,0>,0.0000001} #end         
  #ifndef (ppLeftLittleFingerTip)      #declare ppLeftLittleFingerTip =     sphere{<0,0,0>,0.0000001} #end                  
                                                                                                                                                       
                                                                                                                                                       
  #ifndef (ppRightUpperArm)            #declare ppRightUpperArm =           sphere{<0,0,0>,0.0000001} #end                        
  #ifndef (ppRightForeArm)             #declare ppRightForeArm =            sphere{<0,0,0>,0.0000001} #end                         
  #ifndef (ppRightPalm)                #declare ppRightPalm =               sphere{<0,0,0>,0.0000001} #end                            
  #ifndef (ppRightThumbBase)           #declare ppRightThumbBase =          sphere{<0,0,0>,0.0000001} #end                       
  #ifndef (ppRightThumbMiddle)         #declare ppRightThumbMiddle =        sphere{<0,0,0>,0.0000001} #end                     
  #ifndef (ppRightThumbTip)            #declare ppRightThumbTip =           sphere{<0,0,0>,0.0000001} #end                        
  #ifndef (ppRightFirstFingerBase)     #declare ppRightFirstFingerBase =    sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightFirstFingerMiddle)   #declare ppRightFirstFingerMiddle =  sphere{<0,0,0>,0.0000001} #end               
  #ifndef (ppRightFirstFingerTip)      #declare ppRightFirstFingerTip =     sphere{<0,0,0>,0.0000001} #end                  
  #ifndef (ppRightMiddleFingerBase)    #declare ppRightMiddleFingerBase =   sphere{<0,0,0>,0.0000001} #end           
  #ifndef (ppRightMiddleFingerMiddle)  #declare ppRightMiddleFingerMiddle = sphere{<0,0,0>,0.0000001} #end           
  #ifndef (ppRightMiddleFingerTip)     #declare ppRightMiddleFingerTip =    sphere{<0,0,0>,0.0000001} #end           
  #ifndef (ppRightThirdFingerBase)     #declare ppRightThirdFingerBase =    sphere{<0,0,0>,0.0000001} #end           
  #ifndef (ppRightThirdFingerMiddle)   #declare ppRightThirdFingerMiddle =  sphere{<0,0,0>,0.0000001} #end           
  #ifndef (ppRightThirdFingerTip)      #declare ppRightThirdFingerTip =     sphere{<0,0,0>,0.0000001} #end           
  #ifndef (ppRightLittleFingerBase)    #declare ppRightLittleFingerBase =   sphere{<0,0,0>,0.0000001} #end           
  #ifndef (ppRightLittleFingerMiddle)  #declare ppRightLittleFingerMiddle = sphere{<0,0,0>,0.0000001} #end           
  #ifndef (ppRightLittleFingerTip)     #declare ppRightLittleFingerTip =    sphere{<0,0,0>,0.0000001} #end                  
                                                                                                                                                       
                                                                                                                                                       
  #ifndef(ppRightThigh) #declare ppRightThigh = sphere{<0,0,0>,0.0000001} #end                                      
  #ifndef(ppRightCalf)  #declare ppRightCalf  = sphere{<0,0,0>,0.0000001} #end                                      
  #ifndef(ppRightFoot)  #declare ppRightFoot  = sphere{<0,0,0>,0.0000001} #end
                                                                              
  #ifndef (ppRightBigToeBase)       #declare ppRightBigToeBase =      sphere{<0,0,0>,0.0000001} #end                       
  #ifndef (ppRightBigToeTip)        #declare ppRightBigToeTip =       sphere{<0,0,0>,0.0000001} #end                        
  #ifndef (ppRightFirstToeBase)     #declare ppRightFirstToeBase =    sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightFirstToeMiddle)   #declare ppRightFirstToeMiddle =  sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightFirstToeTip)      #declare ppRightFirstToeTip =     sphere{<0,0,0>,0.0000001} #end                  
  #ifndef (ppRightMiddleToeBase)    #declare ppRightMiddleToeBase =   sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightMiddleToeMiddle)  #declare ppRightMiddleToeMiddle = sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightMiddleToeTip)     #declare ppRightMiddleToeTip =    sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightThirdToeBase)     #declare ppRightThirdToeBase =    sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightThirdToeMiddle)   #declare ppRightThirdToeMiddle =  sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightThirdToeTip)      #declare ppRightThirdToeTip =     sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightLittleToeBase)    #declare ppRightLittleToeBase =   sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightLittleToeMiddle)  #declare ppRightLittleToeMiddle = sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppRightLittleToeTip)     #declare ppRightLittleToeTip =    sphere{<0,0,0>,0.0000001} #end                  
                                                                                                                                                       
  #ifndef(ppLeftThigh)  #declare ppLeftThigh  = sphere{<0,0,0>,0.0000001} #end                                      
  #ifndef(ppLeftCalf)   #declare ppLeftCalf   = sphere{<0,0,0>,0.0000001} #end                                      
  #ifndef(ppLeftFoot)   #declare ppLeftFoot   = sphere{<0,0,0>,0.0000001} #end
                                                                              
  #ifndef (ppLeftBigToeBase)        #declare ppLeftBigToeBase =       sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftBigToeTip)         #declare ppLeftBigToeTip =        sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftFirstToeBase)      #declare ppLeftFirstToeBase =     sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftFirstToeMiddle)    #declare ppLeftFirstToeMiddle =   sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftFirstToeTip)       #declare ppLeftFirstToeTip =      sphere{<0,0,0>,0.0000001} #end                           
  #ifndef (ppLeftMiddleToeBase)     #declare ppLeftMiddleToeBase =    sphere{<0,0,0>,0.0000001} #end                                 
  #ifndef (ppLeftMiddleToeMiddle)   #declare ppLeftMiddleToeMiddle =  sphere{<0,0,0>,0.0000001} #end                                 
  #ifndef (ppLeftMiddleToeTip)      #declare ppLeftMiddleToeTip =     sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppLeftThirdToeBase)      #declare ppLeftThirdToeBase =     sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppLeftThirdToeMiddle)    #declare ppLeftThirdToeMiddle =   sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppLeftThirdToeTip)       #declare ppLeftThirdToeTip =      sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppLeftLittleToeBase)     #declare ppLeftLittleToeBase =    sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppLeftLittleToeMiddle)   #declare ppLeftLittleToeMiddle =  sphere{<0,0,0>,0.0000001} #end                 
  #ifndef (ppLeftLittleToeTip)      #declare ppLeftLittleToeTip =     sphere{<0,0,0>,0.0000001} #end                  




#end


#include "pphuman001textures.inc"  
#include concat(ppModelPrefix,"definition.inc")

ppAddBodyParts()
ppAddJoints()

#include concat(ppModelPrefix,"scaling.inc")
ppScaleBodyParts()




#if (strcmp(ppCamera,"AnatomyCamera")=0)
  camera {
    location <7, 1,0>
    look_at <0, 1, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
  light_source { <10, 4,10> color rgb<1, 1,1>} 
  
  object {ppAnatomyScale}
  
  #declare ppBodyPartListOrientation[ppLeftFootRef]=<0,0,0>;
  #declare ppBodyPartListPosition[ppLeftFootRef]   =<0,0,0>;
//  #declare ppBodyPartListOrientation[ppRightLittleFingerTipRef]=<0,0,0>;
//  #declare ppBodyPartListPosition[ppRightLittleFingerTipRef]   =<0,0,0>;

  ppCalculateBodyPartTransformations()

  #declare ppPerson = ppBuildPerson()  
  object {ppPerson translate -ppBodyPartListPosition[ppRightFootRef]*x/2}
  
#end             
  
