/***************************************************************************************************/
/* pprandomoutfit.inc  - Copyright Chris Bartlett Oct 2005.                                        */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/


// Define the list of costume elements required 
#declare ppCostumeItems = array [2] {
  "ppshorts1.inc",
  "ppshirts1.inc",
}  

#if ((rand(ppRandomStream)>0.8 & strcmp(ppGender,"female")=0) | (rand(ppRandomStream)>0.4 & strcmp(ppGender,"male")=0))
  #declare ppTrousersOrShorts = "Shorts"; #else #declare ppTrousersOrShorts  = "Trousers";
#end
#declare ppLegLength = rand(ppRandomStream);


#declare ppWaistHeight       = 0.20;  // How far above the hips
#declare ppWaistBandHeight   = 0.025; // Height of the waist band

// Most legwear is blue/black
#if (rand(ppRandomStream)<0.9)
  #declare ppTrouserLegTexture = texture {
    pigment {color rgb <0.4*rand(ppRandomStream),0.6*rand(ppRandomStream),1*rand(ppRandomStream)>}  
    normal {bumps 0.8 scale <0.1,0.07,0.1>} 
    scale 0.5
  }
#else  // But some is quite bright
  #declare ppTrouserLegTexture = texture {
    pigment {color rgb <rand(ppRandomStream),rand(ppRandomStream),rand(ppRandomStream)>}  
    normal {bumps 0.8 scale <0.1,0.07,0.1>} 
    scale 0.5
  }
#end

#declare ppTrouserWaistBandTexture = texture {ppTrouserLegTexture}

// Most seams are the same colour as the main material
#if (rand(ppRandomStream)<0.9)
  #declare ppTrouserSeamTexture = texture {ppTrouserLegTexture}
#else // But not all
  #declare ppTrouserSeamTexture = texture {
    pigment {color rgb <rand(ppRandomStream),rand(ppRandomStream),rand(ppRandomStream)>}
  }
#end

#declare ppFabricOffSet = 0.009*rand(ppRandomStream);  
#declare ppFabricBumpiness = 0.05*rand(ppRandomStream);


#declare ppWaistHeight       = 0.1+0.27*rand(ppRandomStream);    // How far above the hips

#declare ppTopColour = <rand(ppRandomStream),rand(ppRandomStream),rand(ppRandomStream)>;
#declare ppTopTexture = texture {
  pigment {color rgb ppTopColour}  
  normal {bumps 0.8*rand(ppRandomStream) scale <0.1,0.07,0.1>} 
  scale 0.5
}

// The shoulder straps are often the same colour as the main material
#if (rand(ppRandomStream)<0.9)
  #declare ppShoulderTexture = texture {ppTopTexture}  
#else  // But not always
  #declare ppShoulderColour = <rand(ppRandomStream),rand(ppRandomStream),rand(ppRandomStream)>;
  #declare ppShoulderTexture = texture {
    pigment {color rgb ppShoulderColour}  
    normal {bumps 0.8*rand(ppRandomStream) scale <0.1,0.07,0.1>} 
    scale 0.5
  }
#end

#ifndef(ppFabricOffSet)    #declare ppFabricOffSet = 0.025*rand(ppRandomStream);     #end
#ifndef(ppFabricBumpiness) #declare ppFabricBumpiness = 0.025*rand(ppRandomStream);  #end


#ifndef (ppVerbose) #declare ppVerbose = 0; #end
#if (ppVerbose) #debug concat("Outfit : ",ppRandomOutfit,"\n") #end
