/***************************************************************************************************/
/* pprandy.inc  - Copyright Chris Bartlett October 2004                                             */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/

#ifndef (ppRandySeed) #declare ppRandySeed = seed(865);  #end

#declare ppModelPrefix = "ppr1";            // Randy is modeled using files with this prefix 
#declare ppCharacterTemplate = "pphuman001";// Randy is a human 

// Randy can be male or female. 
#if (rand(ppRandySeed)>0.5) 
  #declare ppGender = "male"; 
#else                       
  #declare ppGender = "female";
#end 


                                                                                // Recommended Values
                                                                                // ******************
//#ifndef (ppSkinDarkness)         #declare ppSkinDarkness       = 0.7+rand(ppRandySeed)*7.3;  #end // 0.7 to 8       1 is default, 2 is more dark
//#ifndef (ppSkinRedness)          #declare ppSkinRedness        = 0.9+rand(ppRandySeed)*1.1;  #end // 0.9 to 2       1 is not very red, 1.5 is redder  
//#ifndef (ppSkinNoiseGenerator)   #declare ppSkinNoiseGenerator = 3;                          #end // See noise_generator in the POV-Ray Help 

#declare ppSkinDarkness       = 0.7+rand(ppRandySeed)*7.3;  // 0.7 to 8       1 is default, 2 is more dark
#declare ppSkinRedness        = 0.9+rand(ppRandySeed)*1.1;  // 0.9 to 2       1 is not very red, 1.5 is redder  
#declare ppSkinNoiseGenerator = 3;                          // See noise_generator in the POV-Ray Help 

#ifndef (ppEyeColour)            #declare ppEyeColour     = ceil(rand(ppRandySeed)*2.99+0.01); #end // 1=Blue, 2=Brown, 3=Green
#ifndef (ppEyeBrightness)        #declare ppEyeBrightness = 0.5+rand(ppRandySeed);             #end // 0.5 = Dark, 1.5 = Bright    
#ifndef (ppEyePupil)             #declare ppEyePupil      = 0.35+rand(ppRandySeed);            #end // 1.35 = dilated (big black bit), 0.35 = constricted (small black bit) 

#ifndef (ppEyePosition)          #declare ppEyePosition     = <13.2, 80.6, -3.5>;              #end // This needs to match the model prefix below:
                                                                                            
#ifndef (ppEyeshadowColour)       #declare ppEyeshadowColour  = 1;                               #end // More or less any colour you want
#ifndef (ppEyeshadowExtent)      #declare ppEyeshadowExtent = 0.2+rand(ppRandySeed)*1.3;       #end // 0.2 to 1.5     1 is default
#ifndef (ppBlusherColour)         #declare ppBlusherColour    = <1,0,0,0.5>;                     #end // More or less any colour you want
#ifndef (ppBlusherExtent)        #declare ppBlusherExtent   = 0.1;                             #end // 0.3 to 1       0.4 is default

#ifndef (ppLashLength)           #declare ppLashLength    = 10+rand(ppRandySeed)*20;           #end // 10    to 30 
#ifndef (ppLashDensity)          #declare ppLashDensity   = 0.5+rand(ppRandySeed)*0.5;         #end // 0.5   to 1 
#ifndef (ppLashThickness)        #declare ppLashThickness = 0.009+rand(ppRandySeed)*0.027;     #end // 0.009 to 0.036 
#ifndef (ppLashColour)           #declare ppLashColour    = <0.5,0.3,0.3>;                     #end //
   
#ifndef (ppEyebrowHairThickness) #declare ppEyebrowHairThickness = 0.030;            #end // 0.009 to 0.036 
#ifndef (ppEyebrowHairColour)    #declare ppEyebrowHairColour    = ppLashColour;     #end // Yellow
#ifndef (ppLipColour)             #declare ppLipColour             = <1,0.5,0.5,0.4>;  #end // The Transparency defines how much affect the skin colour has on the lip colour  
//#ifndef (ppHairThickness)        #declare ppHairThickness = 0.004;           #end // 0.003 = Thin Hair, 0.009 = Thick Hair (Thin Hair needs more hairs and takes longer) 

#if (strcmp(ppGender,"male")=0)
  #declare ppChestSize  = 0.5;
  #declare ppBreastSize = 0.5;
#else
  #declare ppChestSize  = 0.8+rand(ppRandySeed)*0.4;
  #declare ppBreastSize = 0.9+rand(ppRandySeed)*0.2;
#end

