/***************************************************************************************************/
/* pps2hairline.inc  - Copyright Chris Bartlett 01 Feb 2004                                        */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/
#ifndef (ppCamera) #declare ppCamera="HairLine"; #end  
#ifndef (ppFace)
  #declare ppSkinTexture = texture {pigment {color rgb <1,1,1>}}
  #include "pps2face.inc"       
#end
#ifndef (ppBobbleHat) #declare ppBobbleHat=0; #end

#declare ppHairLine = difference {
  object {ppSkullShape scale 1.01}
  object {ppSkullShape}
  plane {<0,1.25,1>,0 translate -z*0.25} 
  #if (ppBobbleHat=1) plane {-<0,1,1.15>,0 translate <0,1.1,-0.25>} #end 
  cylinder {<-3,0,0><3,0,0>,0.3 scale <1.05,1.25,0.90> translate <0,-0.2,0.08>} // Around Ear
  cone {<0,0,0>,0.5,<0,2,0>,0.75 rotate <-65, 35,0> translate -z*0.1} // Up From Temple on Right
  cone {<0,0,0>,0.5,<0,2,0>,0.75 rotate <-65,-35,0> translate -z*0.1} // Up From Temple on Left   
  scale 26
  translate <0,98,3>
}

#declare ppHairLineComplete = 1;

#if (strcmp(ppCamera,"HairLine")=0)
  camera {
    location <0, 0, -30>
    look_at <0, -4, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>} 
   
  object {ppHairLine scale 1/40 rotate -x*90   pigment {color rgb <1,0.8,0.8>} scale 1.5 translate < 0, 0.5,0>}
  object {ppHairLine scale 1/40 rotate  y*00   pigment {color rgb <1,0.8,0.8>} scale 1.5 translate <-4,-5.5,0>}
  object {ppHairLine scale 1/40 rotate  y*90   pigment {color rgb <1,0.8,0.8>} scale 1.5 translate < 4, 0.5,0>}
  object {ppHairLine scale 1/40 rotate -y*90   pigment {color rgb <1,0.8,0.8>} scale 1.5 translate <-4, 0.5,0>}
  object {ppHairLine scale 1/40 rotate  y*180  pigment {color rgb <1,0.8,0.8>} scale 1.5 translate < 4,-5.5,0>}
  
  cylinder {<-25,0.5,0><25,0.5,0>0.025 pigment {rgb <1,1,0>}}
  cylinder {<-25,-5.5,0><25,-5.5,0>0.025 pigment {rgb <1,1,0>}}
  
  cylinder {< 4,-25,0>< 4,25,0>0.025 pigment {rgb <1,1,0>}}
  cylinder {<-4,-25,0><-4,25,0>0.025 pigment {rgb <1,1,0>}}
   
#end                                                    
