/***************************************************************************************************/
/* ppshorthair.inc  - Copyright Chris Bartlett 01 Aug 2004                                         */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/
#ifndef (ppCamera)      #declare ppCamera="HairCamera"; #end
#ifndef (ppModelPrefix) #declare ppModelPrefix = "pps2";  #end
#ifndef (ppGender)      #declare ppGender = "female";   #end

#if (strcmp(ppModelPrefix,"f2")=0 & strcmp(ppModelPrefix,"s1")=0 & strcmp(ppModelPrefix,"s2")=0) #include "pphairline.inc"  
#else #include concat(ppModelPrefix,"hairline.inc")  
#end 

#include "transforms.inc"

#ifndef (ppHairLineComplete) #declare ppHairLineComplete = 0; #end
#if (ppHairLineComplete = 0) #declare ppHairLine = union {object{ppHairLine} object{ppHairLine scale <-1,1,1>}}  #end


#ifndef (ppHairNumber)       #declare ppHairNumber = 20; #end
#ifndef (ppHairThickness)    #declare ppHairThickness = 0.005; #end
#ifndef (ppHairLength)       #declare ppHairLength = 0.5; #end          // 0 to 2
#ifndef (ppHairRandomness)       #declare ppHairRandomness = 0; #end    // Degrees left or right that the hair can turn

#ifndef (ppHairFringeLength) #declare ppHairFringeLength = 2; #end      // 0 to 0.8
#ifndef (ppHairFringeDef)    #declare ppHairFringeDef = <150,20,-10>; #end
#ifndef (ppHairFringeSplay)  #declare ppHairFringeSplay = 1; #end
#ifndef (ppHairExclude)      #declare ppHairExclude = 0; #end           // 0=Include Every Hair, 1=Exclude Main Hair, 2=Exclude Fringe, 3=Both
#ifndef (ppHairCentre)       #declare ppHairCentre = <0,90,30>; #end    // The logical centre from which hairs radiate
#ifndef (ppHairSeed)         #local ppHairSeed = 1; #else #local ppHairSeed = ppHairSeed + 1; #end
#ifndef (ppHairTexture)      
  #ifndef (ppHairColour)     #declare ppHairColour = <1,1,0>; #end 
  #declare ppHairTexture = texture {pigment {color ppHairColour} finish {phong 0.35}};
#end 
#ifndef (ppHairLineVisible) #declare ppHairLineVisible = 2; #end        // 0=Invisible, 1=Hairs Visible, 2=Solid Hair Colour

#if (ppHairExclude=3) #declare ppHair = object {          // Start of ppHair declaration when only the hairline object is required
#else                 #declare ppHair = union {          // Start of ppHair declaration when some hair is expected
#end

  #switch (ppHairLineVisible)
    #case (1)
      object {ppHairLine scale <-1,1,1>
        texture { 
          pigment {spotted 
            color_map {
              [0    color <1,1,1,0.95>]
              [0.6  color <1,1,1,0.95>]
              [0.6  color ppHairColour+<0,0,0,0.6>]
              [1    color ppHairColour+<0,0,0,0.5>]
            }
            scale 0.1 
          }
        finish {phong 0.05}
        }  
      }
    #break
    #case (2)
      object {ppHairLine scale <-1,1,1> 
        texture {
          pigment {color ppHairColour+<0,0,0,0.6>}  // Add a bit of transparency
          finish {phong 0.05}
        }  
      }
    #break
    #case (-1)
      object {ppHairLine 
        translate -ppHairCentre scale <-1.1,1.1,1.1> translate ppHairCentre
        texture {
          pigment { cylindrical  frequency 40 turbulence 0.5
            color_map {
              [0    color ppHairColour]
              [0.55 color ppHairColour*0.5]
              [0.90 color ppHairColour]
              [0.98  color <1,1,1,1>]
              [1    color <1,1,1,1>]
            }
            scale <100,1,200> rotate <0,-45,90> translate ppHairCentre
          }
          finish {phong 0.05}
        }  
//        texture { 
//          pigment {spotted 
//            color_map {
//              [0    color <1,1,1,0.95>]
//              [0.6  color <1,1,1,0.95>]
//              [0.6  color ppHairColour+<0,0,0,0.6>]
//              [1    color ppHairColour+<0,0,0,0.5>]
//            }
//            scale 0.1 
//          }
//          finish {phong 0.05}
//        }  
      }
    #break
    #else
  #end
  
  
  #local ppHairNormal = <0,0,0>;
  #local ppHairSeedRef = seed(ppHairSeed); 
  #local ppHairLineCentred = object {ppHairLine translate -ppHairCentre} 
  #if (strcmp(ppGender,"male")=0) #local ppHairRotateByDistance = 0.65;
  #else #local ppHairRotateByDistance = 1; 
  #end
  
  #if (ppHairExclude=3) #local ppHairCount = ppHairNumber; #else #local ppHairCount = 0; #end
  #while (ppHairCount < ppHairNumber)   
    #local ppHairDirection = <2*rand(ppHairSeedRef)-1,2*rand(ppHairSeedRef)-1,2*rand(ppHairSeedRef)-1>;
    #local ppHairRootPos = trace (ppHairLineCentred, ppHairDirection,0-ppHairDirection,ppHairNormal);      // The TRACE command
    #if (vlength(ppHairNormal)!=0)          // i.e. If we hit the surface
      #local ppHairOccurs   = 1;
      #local ppHairInFringe = 0;   
      #if (ppHairRootPos.x >= -ppHairFringeDef.x 
         & ppHairRootPos.x <= ppHairFringeDef.x 
         & ppHairRootPos.y >= ppHairFringeDef.y 
         & ppHairRootPos.z <= ppHairFringeDef.z) 
         #local ppHairInFringe = 1; #end
      #if (ppHairExclude = 1 & !ppHairInFringe) #local ppHairOccurs = 0; #end
      #if (ppHairExclude = 2 & ppHairInFringe)  #local ppHairOccurs = 0; #end
      #if (ppHairOccurs) 
        #if (abs(ppHairRootPos.y) < 30) #local hairThicknessScale = 3-abs(ppHairRootPos.y)/15; #else #local hairThicknessScale = 1; #end 
        #local ppHairNormal = -ppHairNormal;  // Invert the Normal to point the hair outwards        
        #local ppHairThick = ppHairThickness*hairThicknessScale;
        #local ppHairBoxSize = 0.4 + ppHairThick;
        intersection {
          #if (!ppHairInFringe)                                           // A ppHair that is part of the Main Hair
            torus {0.4,ppHairThick rotate z*90 translate z*0.4}
            box {<-ppHairThick,0,-ppHairThick><ppHairThick,ppHairBoxSize,ppHairLength>}  
            texture {ppHairTexture translate ppHairRootPos}
          #else                                                         // A ppHair that is part of the Fringe
            torus {0.4,ppHairThick rotate z*90 translate z*0.4 scale <1,1,1.75>}
            box {<-ppHairThick,0,-ppHairThick><ppHairThick,1,ppHairFringeLength>}  
            texture {ppHairTexture translate ppHairRootPos}                 // The fringe can have a different texture if needed
          #end
          scale 20 * (ppHairRootPos.y+ppHairCentre.y)/100
          #if (!ppHairInFringe)                                           // A ppHair that is part of the Main Hair
            Reorient_Trans(<0,0,1>, <ppHairRootPos.x,0,ppHairRootPos.z>)
            #local ppHairRotationByPosition = ppHairRotateByDistance*3*ppHairRootPos.x - 10 - abs(ppHairRootPos.z);
            #if (ppHairRotationByPosition > 0) rotate -y*ppHairRotationByPosition #end
          #else                                                         // A ppHair that is part of the Fringe
            rotate x*(14+abs(ppHairRootPos.x)*0.8-ppHairFringeSplay) 
            Reorient_Trans(<0,0,1>, <ppHairRootPos.x,0,ppHairRootPos.z>)
          #end
          rotate y*(0.5-rand(ppHairSeedRef))*2*ppHairRandomness  

          Reorient_Trans(<0,1,0>, ppHairNormal) 
          translate ppHairRootPos+ppHairCentre 
        }                                   
      #end
    #local ppHairCount = ppHairCount + 1;
  
    #end                     
  #end 
  
}   // End of ppHair declaration

#if (strcmp(ppCamera,"HairCamera")=0)
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  camera {
//    location <30, 80, -180>
//    look_at <30, 80, 10>
    location <30, 80, -220>
    look_at <30, 80, 10>
    angle 34.3775
  }
  plane {y,8
    pigment {color rgb <0.5,0.7,0.7>}  normal {bumps 0.4 scale 100}
    translate z*1000
  } 
  union {                    
    object {ppHair }    
    sphere {ppHairCentre ,5 texture {pigment {color <0,1,1>}}}
    rotate -y*0
  }
#end             


