/***************************************************************************************************/
/* ppanimation001.inc  - Copyright Chris Bartlett September 2005                                   */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/

// This pose file illustrates the principles used for animation by generating a position interpolated
// between two positions selected from a sequence of positions based upon the clock.


#ifndef(ppCamera) 
  #include "pp00animationexample01.pov"
#else 
  #ifndef (ppAnimationCycleOffset) #declare ppAnimationCycleOffset = 0; #end
  #declare ppClock = mod(ppClock+ppAnimationCycleOffset,1);
  #local ppKeyPoseCount = 8;       // The number of key poses used to generate a complete animation cycle
  #local ppTimings = array[ppKeyPoseCount+1] {0,0.2,0.3,0.4,0.5,0.7,0.8,0.9,1};
  #local ppKeyPose1 = 0;
  #local ppKeyPose2 = 1;
  
  #while (ppClock>=ppTimings[ppKeyPose2])
    #local ppKeyPose1 = ppKeyPose1+1;
    #local ppKeyPose2 = ppKeyPose2+1;
  #end 

  #local ppArrayIndex1 = ppKeyPose1;
  #local ppArrayIndex2 = ppKeyPose2;
  
  #if (ppKeyPose2>ppKeyPoseCount-1) #local ppKeyPose2 = 0; #end
  
  #include concat("ppwalking",str(ppKeyPose1,1,0),".inc")
  ppStashJointRotations() 
  #include concat("ppwalking",str(ppKeyPose2,1,0),".inc")
  
  ppInterpolatePose((ppClock-ppTimings[ppArrayIndex1])/(ppTimings[ppArrayIndex2]-ppTimings[ppArrayIndex1]))  

//  #fopen ppFileHandle "walking.log" append 
//  #write (ppFileHandle,concat("Pose: ",str(clock*(ppFrameCount-1)+1,2,0)," Key Pose 1: ",str(ppKeyPose1,1,0)," Key Pose 2: ",str(ppKeyPose2,1,0)," Array Index 1: ",str(ppArrayIndex1,1,0)," Array Index 2: ",str(ppArrayIndex2,1,0)," Clock: ",str(clock,0,3)," Interpolation: ",str((ppClock-ppTimings[ppArrayIndex1])/(ppTimings[ppArrayIndex2]-ppTimings[ppArrayIndex1]),0,3),"\n"))
#end
